---
title: "Clipboard"
enterprise: true
framework: javascript
version: "36.1.0"
---

# Clipboard

You can copy and paste items to and from the grid using the system clipboard.

## How to copy

Copying from the grid is **enabled by default** for enterprise users. To copy your selection to the system clipboard, you can use the keybind `^ Ctrl`+`C`, or right click on a cell and select 'Copy' from the context menu. Unless [Cell Selection](https://www.ag-grid.com/javascript-data-grid/cell-selection/) or [Row Selection](https://www.ag-grid.com/javascript-data-grid/row-selection/) is enabled, you will only be copying from the currently focused cell.

When copying multiple cells, the contents will be copied in an Excel compatible format, with fields separated by a `\t` (tab) character.

## Copying Cell Ranges

When [Cell Ranges](https://www.ag-grid.com/javascript-data-grid/cell-selection/) are enabled by setting `gridOptions.cellSelection=true`, copying will copy the Cell Range's content to your clipboard. Select a range by clicking on a cell and dragging with the mouse, then copy with the `^ Ctrl`+`C` keybind.

Multiple cell ranges can be selected at once using `^ Ctrl` and dragging with the mouse. When copying, all ranges will be copied to the clipboard. Note that the relative positions of multiple ranges is not preserved when copying, they are stacked vertically in the clipboard.

In the below example try:

- Select a cell range with click & drag
- Copy with `^ Ctrl`+`C`
- Paste into an external program / text editor.

#### Copying Cell Ranges

```ts
import {
  ClientSideRowModelModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
]);

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs: [
    { field: "athlete", minWidth: 200 },
    { field: "age" },
    { field: "country", minWidth: 150 },
    { field: "year" },
    { field: "date", minWidth: 150 },
    { field: "sport", minWidth: 150 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ],

  defaultColDef: {
    editable: true,
    flex: 1,
    minWidth: 100,
  },

  cellSelection: true,
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
```

[Live example: Copying Cell Ranges](https://www.ag-grid.com/examples/clipboard/copy-range/typescript)

## Copying Rows

When [Row Selection](https://www.ag-grid.com/javascript-data-grid/row-selection/) is enabled by setting `gridOptions.rowSelection.mode` to either `"singleRow"` or `"multiRow"`, the default behaviour is to copy only the focused cell to the clipboard. In order to copy the whole row, enable the `gridOptions.rowSelection.copySelectedRows` flag.

```js
const gridOptions = {
    rowSelection: {
        mode: 'multiRow',
        copySelectedRows: true,
    },

    // other grid options ...
}
```

The below example demonstrates copying rows. Initially, pressing `^ Ctrl`+C will select the focused cell, regardless of which rows have been selected. You can change this behaviour by toggling the "Copy Selected Rows" checkbox to enable the `copySelectedRows` flag:

- Toggle the "Copy Selected Rows" checkbox on
- Select one or more rows in the example below and press `^ Ctrl`+C
- Paste copied content in a text editor
- When the "Copy Selected Rows" checkbox is toggled on, the pasted content includes all selected rows. When the "Copy Selected Rows" checkbox is toggled off, the pasted content includes only the focussed cell.

#### Copying Rows

```ts
import {
  ClientSideRowModelModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  RowSelectionModule,
  TextEditorModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
  RowSelectionModule,
]);

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs: [
    { field: "athlete", minWidth: 200 },
    { field: "age" },
    { field: "country", minWidth: 150 },
    { field: "year" },
    { field: "date", minWidth: 150 },
    { field: "sport", minWidth: 150 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ],

  defaultColDef: {
    editable: true,
    flex: 1,
    minWidth: 100,
  },

  rowSelection: {
    mode: "multiRow",
    copySelectedRows: false,
  },
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));

function toggleCopyRows() {
  gridApi.setGridOption("rowSelection", {
    mode: "multiRow",
    copySelectedRows:
      document.querySelector<HTMLInputElement>("#toggle-copy-rows")?.checked ??
      false,
  });
}

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).toggleCopyRows = toggleCopyRows;
}
```

[Live example: Copying Rows](https://www.ag-grid.com/examples/clipboard/copy-row/typescript)

## Copying Headers

The column headers can be copied to the clipboard in addition to the cell contents by enabling the option `copyHeadersToClipboard`.

```js
const gridOptions = {
    copyHeadersToClipboard: true,

    // other grid options ...
}
```

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `copyHeadersToClipboard` | `boolean` |  | `false` | Set to `true` to also include headers when copying to clipboard using ^ Ctrl+C clipboard. Default: `false` Module: [`ClipboardModule`](https://www.ag-grid.com/javascript-data-grid/modules/). |

In the below example try:

- Select a cell range with click & drag
- Copy with `^ Ctrl`+`C`
- Paste into an external program / text editor, note that the column headers were also copied.

#### Copying Cell Ranges and Headers

```ts
import {
  ClientSideRowModelModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
]);

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs: [
    { field: "athlete", minWidth: 200 },
    { field: "age" },
    { field: "country", minWidth: 150 },
    { field: "year" },
    { field: "date", minWidth: 150 },
    { field: "sport", minWidth: 150 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ],

  defaultColDef: {
    editable: true,
    flex: 1,
    minWidth: 100,
  },

  cellSelection: true,
  copyHeadersToClipboard: true,
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
```

[Live example: Copying Cell Ranges and Headers](https://www.ag-grid.com/examples/clipboard/copy-range-with-headers/typescript)

## Custom Clipboard Interaction

If you want to do the copy to clipboard yourself (i.e. not use the grid's clipboard interaction) then implement the callback `sendToClipboard(params)`. Use this if you are in a non-standard web container that has a bespoke API for interacting with the clipboard. The callback gets the data to go into the clipboard, it's your job to call the bespoke API.

The example below shows using `sendToClipboard(params)`, but rather than using the clipboard, demonstrates the callback by just printing the data to the console.

#### Controlling Clipboard Copy

```ts
import {
  ClientSideRowModelModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  RowSelectionModule,
  SendToClipboardParams,
  TextEditorModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  RowSelectionModule,
  ClientSideRowModelModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
]);

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs: [
    { field: "athlete", minWidth: 200 },
    { field: "age" },
    { field: "country", minWidth: 150 },
    { field: "year" },
    { field: "date", minWidth: 150 },
    { field: "sport", minWidth: 150 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ],

  defaultColDef: {
    editable: true,
    flex: 1,
    minWidth: 100,
  },

  cellSelection: true,
  rowSelection: { mode: "multiRow" },

  sendToClipboard: sendToClipboard,
};

function sendToClipboard(params: SendToClipboardParams) {
  console.log("send to clipboard called with data:");
  console.log(params.data);
}

function onBtCopyRows() {
  gridApi!.copySelectedRowsToClipboard();
}

function onBtCopyRange() {
  gridApi!.copySelectedRangeToClipboard();
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).onBtCopyRows = onBtCopyRows;
  (<any>window).onBtCopyRange = onBtCopyRange;
}
```

[Live example: Controlling Clipboard Copy](https://www.ag-grid.com/examples/clipboard/custom/typescript)

## Copying via the API

You can use the Grid API methods: `copySelectedRowsToClipboard(...)` and `copySelectedRangeToClipboard(...)` to copy rows or ranges respectively, these API calls take optional parameters to enable copying column and group headers.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `copySelectedRangeToClipboard` | `Function` |  |  | Copies the selected ranges to the clipboard. Module: [`ClipboardModule`](https://www.ag-grid.com/javascript-data-grid/modules/). |
| `copySelectedRowsToClipboard` | `Function` |  |  | Copies the selected rows to the clipboard. Module: [`ClipboardModule`](https://www.ag-grid.com/javascript-data-grid/modules/). |

## How to Cut

Cut from the grid is **enabled by default** for enterprise users. To cut your selection to the system clipboard, you can use the keybind `^ Ctrl`+`X`, or right click on a cell and select 'Cut' from the context menu. Unless [Range Selection](https://www.ag-grid.com/javascript-data-grid/cell-selection/) or [Row Selection](https://www.ag-grid.com/javascript-data-grid/row-selection/) is enabled, you will only be copying from the currently focused cell.

The cut operations will work exactly the same as the copy operations, with the addition that data will be removed from the grid afterwards, so the cut operations will use the same properties described above to customise the `copy` process.

## Disabling Cut

Since `Cut` is a destructive process, the `suppressCutToClipboard` property was added to the Grid Options.

```js
const gridOptions = {
    suppressCutToClipboard: true,

    // other grid options ...
}
```

This is demonstrated in the example below. Note the following:

- Selecting a cell and pressing `^ Ctrl`+`X` will not `copy` or `cut` the data.
- The context menu will not show an option to `Cut`.

#### Clipboard Suppress Cut

```ts
import {
  ClientSideRowModelModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
]);

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs: [
    { field: "athlete", minWidth: 200 },
    { field: "age" },
    { field: "country", minWidth: 150 },
    { field: "year" },
    { field: "date", minWidth: 150 },
    { field: "sport", minWidth: 150 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ],

  defaultColDef: {
    editable: true,
    flex: 1,
    minWidth: 100,
  },

  cellSelection: true,
  suppressCutToClipboard: true,
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
```

[Live example: Clipboard Suppress Cut](https://www.ag-grid.com/examples/clipboard/suppress-cut/typescript)

## How to Paste

Paste is enabled by default in the enterprise version and is possible as long as the cells you're pasting into are [editable](https://www.ag-grid.com/javascript-data-grid/cell-editing/) (non-editable cells cannot be modified, even with a paste operation). You can paste using the keybind `^ Ctrl`+`V` while focus is on the grid.

The behaviour of paste changes depending on whether you have a single cell or a range selected:

- When a **single cell is selected**. The paste will proceed starting at the selected cell if multiple cells are to be pasted.
- When a **range of cells selected**. If the selected range being pasted is larger than copied range, it will repeat if it fits evenly, otherwise it will just copy the cells into the start of the range.

## Disabling Paste

You can turn paste operations off for the entire grid, by setting the grid property `suppressClipboardPaste=true`.

Or you can disable pasting for a specific column or cell by setting the property `suppressPaste` on the column definition. This can be a boolean or a function (use a function to specify for a particular cell, or boolean for the whole column).

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `suppressPaste` | `boolean \| SuppressPasteCallback` |  |  | Pasting is on by default as long as cells are editable (non-editable cells cannot be modified, even with a paste operation). Set to `true` turn paste operations off. |

## Processing Pasted Data

The clipboard data will be processed by default [Using the Value Formatter for Export](https://www.ag-grid.com/javascript-data-grid/value-formatters/#formatting-for-export) to format the cells when copied, and [Using the Value Parser for Import](https://www.ag-grid.com/javascript-data-grid/value-parsers/#use-value-parser-for-import) to format the cells when pasted.

It is possible to override this behaviour specifically for the clipboard. This can be done either on individual cells or the whole paste operation.

### Processing Individual Cells

The interfaces and parameters for processing individual cells are as follows:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `processCellForClipboard` | `ProcessCellForClipboard` |  |  | Allows you to process cells for the clipboard. Handy if for example you have `Date` objects that need to have a particular format if importing into Excel. Module: [`ClipboardModule`](https://www.ag-grid.com/javascript-data-grid/modules/). |
| `processHeaderForClipboard` | `ProcessHeaderForClipboard` |  |  | Allows you to process header values for the clipboard. Module: [`ClipboardModule`](https://www.ag-grid.com/javascript-data-grid/modules/). |
| `processGroupHeaderForClipboard` | `ProcessGroupHeaderForClipboard` |  |  | Allows you to process group header values for the clipboard. Module: [`ClipboardModule`](https://www.ag-grid.com/javascript-data-grid/modules/). |
| `processCellFromClipboard` | `ProcessCellFromClipboard` |  |  | Allows you to process cells from the clipboard. Handy if for example you have number fields and want to block non-numbers from getting into the grid. Module: [`ClipboardModule`](https://www.ag-grid.com/javascript-data-grid/modules/). |

These three callbacks above are demonstrated in the example below. Note the following:

- When cells are copied to the clipboard, values are prefixed with 'C-'. Cells can be copied by dragging a range with the mouse and hitting `^ Ctrl`+`C`.
- When cells are pasted from the clipboard, values are prefixed with 'Z-'. Cells can be pasted by hitting `^ Ctrl`+`V`.
- When headers are copied to the clipboard, values are prefixed with 'H-'. Headers can be copied by using the context menu.
- When group headers are copied to the clipboard, values are prefixed with 'GH-'. Headers can be copied by using the context menu.

#### Example Process

```ts
import {
  ClientSideRowModelModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  ProcessCellForExportParams,
  ProcessGroupHeaderForExportParams,
  ProcessHeaderForExportParams,
  TextEditorModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
]);

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs: [
    {
      headerName: "Participants",
      children: [
        { field: "athlete", headerName: "Athlete Name", minWidth: 200 },
        { field: "age" },
        { field: "country", minWidth: 150 },
      ],
    },
    {
      headerName: "Olympic Games",
      children: [
        { field: "year" },
        { field: "date", minWidth: 150 },
        { field: "sport", minWidth: 150 },
        { field: "gold" },
        { field: "silver", suppressPaste: true },
        { field: "bronze" },
        { field: "total" },
      ],
    },
  ],

  defaultColDef: {
    editable: true,
    flex: 1,
    minWidth: 100,
    cellDataType: false,
  },

  cellSelection: true,

  processCellForClipboard: processCellForClipboard,
  processHeaderForClipboard: processHeaderForClipboard,
  processGroupHeaderForClipboard: processGroupHeaderForClipboard,
  processCellFromClipboard: processCellFromClipboard,
};

function processCellForClipboard(params: ProcessCellForExportParams) {
  return "C-" + params.value;
}

function processHeaderForClipboard(params: ProcessHeaderForExportParams) {
  const colDef = params.column.getColDef();
  let headerName = colDef.headerName || colDef.field || "";

  if (colDef.headerName !== "") {
    headerName = headerName.charAt(0).toUpperCase() + headerName.slice(1);
  }

  return "H-" + headerName;
}

function processGroupHeaderForClipboard(
  params: ProcessGroupHeaderForExportParams,
) {
  const colGroupDef = params.columnGroup.getColGroupDef() || ({} as any);
  const headerName = colGroupDef.headerName || "";

  if (headerName === "") {
    return "";
  }

  return "GH-" + headerName;
}

function processCellFromClipboard(params: ProcessCellForExportParams) {
  return "Z-" + params.value;
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
```

[Live example: Example Process](https://www.ag-grid.com/examples/clipboard/process/typescript)

### Processing Data from Clipboard

To have complete control of processing clipboard data when pasting, you can use the callback below:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `processDataFromClipboard` | `ProcessDataFromClipboard` |  |  | Allows complete control of the paste operation, including cancelling the operation (so nothing happens) or replacing the data with other data. Module: [`ClipboardModule`](https://www.ag-grid.com/javascript-data-grid/modules/). |

The following example shows custom code to process the data from the clipboard:

- The cells are coloured based on the colour that the cell content starts with
- Copy a cell range in the grid which includes a cell value that starts with `Red`. Pasting into the grid will paste a custom 4x4 cell grid.
- Copy a cell range in the grid which includes a cell value that starts with `Yellow` and **doesn’t** include any `Red` cell values. Pasting this copied cell range will cancel the paste action and not paste anything
- Any other copied cell data will be pasted as-is

#### Example Process Data

```ts
import {
  CellStyleModule,
  ClientSideRowModelModule,
  ColDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  ProcessDataFromClipboardParams,
  TextEditorModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
import { getData } from "./data";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  TextEditorModule,
  CellStyleModule,
  ClientSideRowModelModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
]);

const columnDefs: ColDef[] = [
  { field: "a" },
  { field: "b" },
  { field: "c" },
  { field: "d" },
  { field: "e" },
];

let gridApi: GridApi;

const gridOptions: GridOptions = {
  rowData: getData(),
  columnDefs: columnDefs,
  cellSelection: true,

  defaultColDef: {
    editable: true,
    minWidth: 120,
    flex: 1,

    cellClassRules: {
      "cell-green": 'value && value.startsWith("Green")',
      "cell-blue": 'value && value.startsWith("Blue")',
      "cell-red": 'value && value.startsWith("Red")',
      "cell-yellow": 'value && value.startsWith("Yellow")',
    },
  },

  processDataFromClipboard,
};

function processDataFromClipboard(
  params: ProcessDataFromClipboardParams,
): string[][] | null {
  let containsRed;
  let containsYellow;
  const data = params.data;

  for (let i = 0; i < data.length; i++) {
    const row = data[i];
    for (let j = 0; j < row.length; j++) {
      const value = row[j];
      if (value) {
        if (value.startsWith("Red")) {
          containsRed = true;
        } else if (value.startsWith("Yellow")) {
          containsYellow = true;
        }
      }
    }
  }

  if (containsRed) {
    // replace the paste request with another
    return [
      ["Custom 1", "Custom 2"],
      ["Custom 3", "Custom 4"],
    ];
  }

  if (containsYellow) {
    // cancels the paste
    return null;
  }

  return data;
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
```

[Live example: Example Process Data](https://www.ag-grid.com/examples/clipboard/process-all/typescript)

### Pasting New Rows at the Bottom of the Grid

By default, when pasting multiple rows near the last record shown in the grid, any rows exceeding the total number of rows shown in the grid will not be pasted.

In order to insert all the copied rows in the grid, a custom `processDataFromClipboard` function is needed to add the necessary number of new rows using the [Transaction Update API](https://www.ag-grid.com/javascript-data-grid/data-update-transactions/#transaction-update-api).

The example below uses a custom `processDataFromClipboard` function to add new rows to the grid, to fit all the copied rows:

- Select the top 3 rows in the grid using `⇧ Shift` + click
- Press `^ Ctrl`+`C` to copy the selected rows
- Select the `Ryan Lochte` cell on the last row and press `^ Ctrl`+`V` to paste the copied rows
- Notice that the `Ryan Lochte` row has been overwritten and 2 extra rows are created at the bottom of the grid to accommodate the additional 2 rows pasted

#### Paste New Rows

```ts
import {
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  ColDef,
  ColumnApiModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  ProcessDataFromClipboardParams,
  RowApiModule,
  RowSelectionModule,
  TextEditorModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ColumnApiModule,
  RowApiModule,
  ClientSideRowModelApiModule,
  NumberEditorModule,
  TextEditorModule,
  RowSelectionModule,
  ClientSideRowModelModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
]);

const columnDefs: ColDef[] = [
  { headerName: "Athlete", field: "athlete", width: 150 },
  { headerName: "Age", field: "age", width: 90 },
  { headerName: "Country", field: "country", width: 120 },
  { headerName: "Year", field: "year", width: 90 },
  { headerName: "Date", field: "date", width: 110 },
  { headerName: "Sport", field: "sport", width: 110 },
];

let gridApi: GridApi;

const gridOptions: GridOptions = {
  defaultColDef: {
    editable: true,
  },
  columnDefs,
  rowSelection: {
    mode: "multiRow",
    checkboxes: false,
    headerCheckbox: false,
    enableClickSelection: true,
    copySelectedRows: true,
  },
  processDataFromClipboard,
};

function processDataFromClipboard(
  params: ProcessDataFromClipboardParams,
): string[][] | null {
  const data = [...params.data];
  const emptyLastRow =
    data[data.length - 1][0] === "" && data[data.length - 1].length === 1;

  if (emptyLastRow) {
    data.splice(data.length - 1, 1);
  }

  const lastIndex = params.api!.getDisplayedRowCount() - 1;
  const focusedCell = params.api!.getFocusedCell();
  const focusedIndex = focusedCell!.rowIndex;

  if (focusedIndex + data.length - 1 > lastIndex) {
    const resultLastIndex = focusedIndex + (data.length - 1);
    const numRowsToAdd = resultLastIndex - lastIndex;

    const rowsToAdd: any[] = [];
    for (let i = 0; i < numRowsToAdd; i++) {
      const index = data.length - 1;
      const row = data.slice(index, index + 1)[0];

      // Create row object
      const rowObject: any = {};
      let currentColumn: any = focusedCell!.column;
      row.forEach((item) => {
        if (!currentColumn) {
          return;
        }
        rowObject[currentColumn.colDef.field] = item;
        currentColumn = params.api!.getDisplayedColAfter(currentColumn);
      });

      rowsToAdd.push(rowObject);
    }

    params.api!.applyTransaction({ add: rowsToAdd });
  }

  return data;
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data) => gridApi!.setGridOption("rowData", data.slice(0, 8)));
```

[Live example: Paste New Rows](https://www.ag-grid.com/examples/clipboard/pasting-extra-rows/typescript)

### Read Only Edit

When the grid is in [Read Only Edit](https://www.ag-grid.com/javascript-data-grid/value-setters/#read-only-edit) mode the `Clipboard` will not update the data inside the grid. Instead the grid fires `cellEditRequest` events allowing the application to process the update request.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `cellEditRequest` | `CellEditRequestEvent` |  |  | Value has changed after editing. Only fires when `readOnlyEdit=true`. |

The example below will show how to update cell value combining the `Clipboard` with `readOnlyEdit=true`.

#### Clipboard - ReadOnlyEdit

```ts
import {
  CellEditRequestEvent,
  ClientSideRowModelModule,
  GetRowIdParams,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { CellSelectionModule, ClipboardModule } from "ag-grid-enterprise";
import { IOlympicDataWithId } from "./interfaces";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelModule,
  ClipboardModule,
  CellSelectionModule,
]);

let gridApi: GridApi<IOlympicDataWithId>;

const gridOptions: GridOptions<IOlympicDataWithId> = {
  columnDefs: [
    { field: "athlete", minWidth: 160 },
    { field: "age" },
    { field: "country", minWidth: 140 },
    { field: "year" },
    { field: "date", minWidth: 140 },
    { field: "sport", minWidth: 160 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ],
  defaultColDef: {
    flex: 1,
    minWidth: 100,
    editable: true,
  },
  getRowId: (params: GetRowIdParams) => String(params.data.id),

  cellSelection: true,
  readOnlyEdit: true,
  onCellEditRequest: onCellEditRequest,
};

let rowImmutableStore: any[];

function onCellEditRequest(event: CellEditRequestEvent) {
  const data = event.data;
  const field = event.colDef.field;
  const newValue = event.newValue;

  const oldItem = rowImmutableStore.find((row) => row.id === data.id);

  if (!oldItem || !field) {
    return;
  }

  const newItem = { ...oldItem };

  newItem[field] = newValue;

  console.log("onCellEditRequest, updating " + field + " to " + newValue);

  rowImmutableStore = rowImmutableStore.map((oldItem) =>
    oldItem.id == newItem.id ? newItem : oldItem,
  );
  gridApi!.setGridOption("rowData", rowImmutableStore);
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: any[]) => {
    data.forEach((item, index) => (item.id = index));
    rowImmutableStore = data;
    gridApi!.setGridOption("rowData", rowImmutableStore);
  });
```

[Live example: Clipboard - ReadOnlyEdit](https://www.ag-grid.com/examples/clipboard/read-only-edit/typescript)

## Changing the Delimiter for Copy & Paste

By default, the grid will use `\t` (tab) as the field delimiter. This is to keep the copy / paste compatible with Excel. If you want another delimiter then you can set the property `gridOptions.clipboardDelimiter` to a value of your choosing.

## Using the Browser's Text Selection

The grid's selection and copy features replace the built-in browser behaviour for selecting and copying text. If you want to use the normal browser behaviour instead, you should set `enableCellTextSelection=true` in the gridOptions. Note the following:

- When `enableCellTextSelection=true`, pressing `^ Ctrl`+`C` doesn’t copy the focused cell value, but only the selected text inside the grid cell. When using AG Grid Enterprise, the user can copy the entire cell value by right-clicking the grid cell to show the [context menu](https://www.ag-grid.com/javascript-data-grid/context-menu/) and clicking the any of the Copy menu items.
- When `enableCellTextSelection=true`, the option `ensureDomOrder=true` needs to be set for correct accessibility support. See [Ensure DOM Element order](https://www.ag-grid.com/javascript-data-grid/accessibility/#ensure-dom-element-order).

> **Note**
>
> This is not an enterprise config and can be used at any time to enable cell text selection.

See this behaviour shown in the example below:

- Focus a grid cell and press `^ Ctrl`+`C`. The cell value will not be copied because no text is selected.
- Click a cell and drag across its value to select the text. Press `^ Ctrl`+`C` and the value will be copied.
- This sample is using AG Grid Community version, so the context menu is not available to copy the focused cell value. In AG Grid Enterprise the context menu will be available to copy the entire focused cell value without having to select it as text.

#### Using Browser text selection

```ts
import {
  ClientSideRowModelModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelModule,
]);

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs: [
    { field: "athlete", minWidth: 200 },
    { field: "age" },
    { field: "country", minWidth: 150 },
    { field: "year" },
    { field: "date", minWidth: 150 },
    { field: "sport", minWidth: 150 },
    { field: "gold" },
    { field: "silver", suppressPaste: true },
    { field: "bronze" },
    { field: "total" },
  ],

  defaultColDef: {
    editable: true,
    flex: 1,
    minWidth: 100,
  },

  ensureDomOrder: true,
  enableCellTextSelection: true,
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
```

[Live example: Using Browser text selection](https://www.ag-grid.com/examples/clipboard/cellTextSelection/typescript)

## Clipboard Events

The following events are relevant to clipboard operations:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `cutStart` | `CutStartEvent` |  |  | Cut operation has started. |
| `cutEnd` | `CutEndEvent` |  |  | Cut operation has ended. |
| `pasteStart` | `PasteStartEvent` |  |  | Paste operation has started. |
| `pasteEnd` | `PasteEndEvent` |  |  | Paste operation has ended. |

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `cellValueChanged` | `CellValueChangedEvent` |  |  | Cell value has changed. This occurs after the following scenarios: - Editing. Will not fire if any of the following are true: new value is the same as old value; `readOnlyEdit = true`; editing was cancelled (e.g. Escape key was pressed); or new value is of the wrong cell data type for the column. - Cut. - Paste. - Cell clear (pressing Delete key). - Fill handle. - Copy range down. - Undo and redo. See [Editing Events](https://www.ag-grid.com/javascript-data-grid/cell-editing/#editing-events) for more information. |

For a cut or paste operation the events will be fired as:

1. One `cutStart`/`pasteStart` event.
2. Many `cellValueChanged` events.
3. One `cutEnd`/`pasteEnd` event.

If the application is doing work each time it receives a `cellValueChanged`, you can use the `cutStart`/`pasteStart` and `cutEnd`/`pasteEnd` events to suspend the applications work and then do the work for all cells impacted by the cut/paste operation after the cut/paste operation.

There are no events triggered by copy to clipboard as this does not change the grid's data.

#### Clipboard Events

```ts
import {
  CellValueChangedEvent,
  ClientSideRowModelModule,
  CutEndEvent,
  CutStartEvent,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  PasteEndEvent,
  PasteStartEvent,
  TextEditorModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
]);

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs: [
    { field: "athlete", minWidth: 200 },
    { field: "age" },
    { field: "country", minWidth: 150 },
    { field: "year" },
    { field: "date", minWidth: 150 },
    { field: "sport", minWidth: 150 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ],

  defaultColDef: {
    editable: true,
    flex: 1,
    minWidth: 100,
  },

  cellSelection: true,

  onCellValueChanged: onCellValueChanged,
  onCutStart: onCutStart,
  onCutEnd: onCutEnd,
  onPasteStart: onPasteStart,
  onPasteEnd: onPasteEnd,
};

function onCellValueChanged(params: CellValueChangedEvent) {
  console.log("Callback onCellValueChanged:", params);
}

function onCutStart(params: CutStartEvent) {
  console.log("Callback onCutStart:", params);
}

function onCutEnd(params: CutEndEvent) {
  console.log("Callback onCutEnd:", params);
}

function onPasteStart(params: PasteStartEvent) {
  console.log("Callback onPasteStart:", params);
}

function onPasteEnd(params: PasteEndEvent) {
  console.log("Callback onPasteEnd:", params);
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
```

[Live example: Clipboard Events](https://www.ag-grid.com/examples/clipboard/clipboard-events/typescript)


---
title: "Clipboard"
enterprise: true
framework: react
version: "36.1.0"
---

# Clipboard

You can copy and paste items to and from the grid using the system clipboard.

## How to copy

Copying from the grid is **enabled by default** for enterprise users. To copy your selection to the system clipboard, you can use the keybind `^ Ctrl`+`C`, or right click on a cell and select 'Copy' from the context menu. Unless [Cell Selection](https://www.ag-grid.com/react-data-grid/cell-selection/) or [Row Selection](https://www.ag-grid.com/react-data-grid/row-selection/) is enabled, you will only be copying from the currently focused cell.

When copying multiple cells, the contents will be copied in an Excel compatible format, with fields separated by a `\t` (tab) character.

## Copying Cell Ranges

When [Cell Ranges](https://www.ag-grid.com/react-data-grid/cell-selection/) are enabled by setting `gridOptions.cellSelection=true`, copying will copy the Cell Range's content to your clipboard. Select a range by clicking on a cell and dragging with the mouse, then copy with the `^ Ctrl`+`C` keybind.

Multiple cell ranges can be selected at once using `^ Ctrl` and dragging with the mouse. When copying, all ranges will be copied to the clipboard. Note that the relative positions of multiple ranges is not preserved when copying, they are stacked vertically in the clipboard.

In the below example try:

- Select a cell range with click & drag
- Copy with `^ Ctrl`+`C`
- Paste into an external program / text editor.

#### Copying Cell Ranges

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  CellSelectionOptions,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

const modules = [
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "athlete", minWidth: 200 },
    { field: "age" },
    { field: "country", minWidth: 150 },
    { field: "year" },
    { field: "date", minWidth: 150 },
    { field: "sport", minWidth: 150 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      editable: true,
      flex: 1,
      minWidth: 100,
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<IOlympicData>
            rowData={data}
            loading={loading}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            cellSelection={true}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Copying Cell Ranges](https://www.ag-grid.com/examples/clipboard/copy-range/reactFunctionalTs)

## Copying Rows

When [Row Selection](https://www.ag-grid.com/react-data-grid/row-selection/) is enabled by setting `gridOptions.rowSelection.mode` to either `"singleRow"` or `"multiRow"`, the default behaviour is to copy only the focused cell to the clipboard. In order to copy the whole row, enable the `gridOptions.rowSelection.copySelectedRows` flag.

```jsx
const rowSelection = useMemo(() => { 
	return {
        mode: 'multiRow',
        copySelectedRows: true,
    };
}, []);

<AgGridReact rowSelection={rowSelection} />
```

The below example demonstrates copying rows. Initially, pressing `^ Ctrl`+C will select the focused cell, regardless of which rows have been selected. You can change this behaviour by toggling the "Copy Selected Rows" checkbox to enable the `copySelectedRows` flag:

- Toggle the "Copy Selected Rows" checkbox on
- Select one or more rows in the example below and press `^ Ctrl`+C
- Paste copied content in a text editor
- When the "Copy Selected Rows" checkbox is toggled on, the pasted content includes all selected rows. When the "Copy Selected Rows" checkbox is toggled off, the pasted content includes only the focussed cell.

#### Copying Rows

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./style.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  RowSelectionModule,
  RowSelectionOptions,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

const modules = [
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
  RowSelectionModule,
];

const GridExample = () => {
  const gridRef = useRef<AgGridReact<IOlympicData>>(null);
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "athlete", minWidth: 200 },
    { field: "age" },
    { field: "country", minWidth: 150 },
    { field: "year" },
    { field: "date", minWidth: 150 },
    { field: "sport", minWidth: 150 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      editable: true,
      flex: 1,
      minWidth: 100,
    };
  }, []);
  const rowSelection = useMemo<
    RowSelectionOptions | "single" | "multiple"
  >(() => {
    return {
      mode: "multiRow",
      copySelectedRows: false,
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  const toggleCopyRows = useCallback(() => {
    gridRef.current!.api.setGridOption("rowSelection", {
      mode: "multiRow",
      copySelectedRows:
        document.querySelector<HTMLInputElement>("#toggle-copy-rows")
          ?.checked ?? false,
    });
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div className="example-wrapper">
          <div className="example-header">
            <label htmlFor="toggle-copy-rows">Copy Selected Rows: </label>
            <input
              type="checkbox"
              id="toggle-copy-rows"
              onChange={toggleCopyRows}
            />
          </div>

          <div style={gridStyle}>
            <AgGridReact<IOlympicData>
              ref={gridRef}
              rowData={data}
              loading={loading}
              columnDefs={columnDefs}
              defaultColDef={defaultColDef}
              rowSelection={rowSelection}
            />
          </div>
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Copying Rows](https://www.ag-grid.com/examples/clipboard/copy-row/reactFunctionalTs)

## Copying Headers

The column headers can be copied to the clipboard in addition to the cell contents by enabling the option `copyHeadersToClipboard`.

```jsx
const copyHeadersToClipboard = true;

<AgGridReact copyHeadersToClipboard={copyHeadersToClipboard} />
```

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `copyHeadersToClipboard` | `boolean` |  | `false` | Set to `true` to also include headers when copying to clipboard using ^ Ctrl+C clipboard. Default: `false` Module: [`ClipboardModule`](https://www.ag-grid.com/react-data-grid/modules/). |

In the below example try:

- Select a cell range with click & drag
- Copy with `^ Ctrl`+`C`
- Paste into an external program / text editor, note that the column headers were also copied.

#### Copying Cell Ranges and Headers

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  CellSelectionOptions,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

const modules = [
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "athlete", minWidth: 200 },
    { field: "age" },
    { field: "country", minWidth: 150 },
    { field: "year" },
    { field: "date", minWidth: 150 },
    { field: "sport", minWidth: 150 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      editable: true,
      flex: 1,
      minWidth: 100,
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<IOlympicData>
            rowData={data}
            loading={loading}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            cellSelection={true}
            copyHeadersToClipboard={true}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Copying Cell Ranges and Headers](https://www.ag-grid.com/examples/clipboard/copy-range-with-headers/reactFunctionalTs)

## Custom Clipboard Interaction

If you want to do the copy to clipboard yourself (i.e. not use the grid's clipboard interaction) then implement the callback `sendToClipboard(params)`. Use this if you are in a non-standard web container that has a bespoke API for interacting with the clipboard. The callback gets the data to go into the clipboard, it's your job to call the bespoke API.

The example below shows using `sendToClipboard(params)`, but rather than using the clipboard, demonstrates the callback by just printing the data to the console.

#### Controlling Clipboard Copy

```tsx
("use client");

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  CellSelectionOptions,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  RowSelectionModule,
  RowSelectionOptions,
  SendToClipboard,
  SendToClipboardParams,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

const modules = [
  NumberEditorModule,
  TextEditorModule,
  RowSelectionModule,
  ClientSideRowModelModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
];

const GridExample = () => {
  const gridRef = useRef<AgGridReact<IOlympicData>>(null);
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "athlete", minWidth: 200 },
    { field: "age" },
    { field: "country", minWidth: 150 },
    { field: "year" },
    { field: "date", minWidth: 150 },
    { field: "sport", minWidth: 150 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      editable: true,
      flex: 1,
      minWidth: 100,
    };
  }, []);
  const rowSelection = useMemo<
    RowSelectionOptions | "single" | "multiple"
  >(() => {
    return { mode: "multiRow" };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  const onBtCopyRows = useCallback(() => {
    gridRef.current!.api.copySelectedRowsToClipboard();
  }, []);

  const onBtCopyRange = useCallback(() => {
    gridRef.current!.api.copySelectedRangeToClipboard();
  }, []);

  const sendToClipboard = useCallback((params: SendToClipboardParams) => {
    console.log("send to clipboard called with data:");
    console.log(params.data);
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div
          style={{ display: "flex", height: "100%", flexDirection: "column" }}
        >
          <div style={{ paddingBottom: "5px" }}>
            <button onClick={onBtCopyRows}>
              Copy Selected Rows to Clipboard
            </button>
            <button onClick={onBtCopyRange}>
              Copy Selected Range to Clipboard
            </button>
          </div>

          <div style={gridStyle}>
            <AgGridReact<IOlympicData>
              ref={gridRef}
              rowData={data}
              loading={loading}
              columnDefs={columnDefs}
              defaultColDef={defaultColDef}
              cellSelection={true}
              rowSelection={rowSelection}
              sendToClipboard={sendToClipboard}
            />
          </div>
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Controlling Clipboard Copy](https://www.ag-grid.com/examples/clipboard/custom/reactFunctionalTs)

## Copying via the API

You can use the Grid API methods: `copySelectedRowsToClipboard(...)` and `copySelectedRangeToClipboard(...)` to copy rows or ranges respectively, these API calls take optional parameters to enable copying column and group headers.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `copySelectedRangeToClipboard` | `Function` |  |  | Copies the selected ranges to the clipboard. Module: [`ClipboardModule`](https://www.ag-grid.com/react-data-grid/modules/). |
| `copySelectedRowsToClipboard` | `Function` |  |  | Copies the selected rows to the clipboard. Module: [`ClipboardModule`](https://www.ag-grid.com/react-data-grid/modules/). |

## How to Cut

Cut from the grid is **enabled by default** for enterprise users. To cut your selection to the system clipboard, you can use the keybind `^ Ctrl`+`X`, or right click on a cell and select 'Cut' from the context menu. Unless [Range Selection](https://www.ag-grid.com/react-data-grid/cell-selection/) or [Row Selection](https://www.ag-grid.com/react-data-grid/row-selection/) is enabled, you will only be copying from the currently focused cell.

The cut operations will work exactly the same as the copy operations, with the addition that data will be removed from the grid afterwards, so the cut operations will use the same properties described above to customise the `copy` process.

## Disabling Cut

Since `Cut` is a destructive process, the `suppressCutToClipboard` property was added to the Grid Options.

```jsx
const suppressCutToClipboard = true;

<AgGridReact suppressCutToClipboard={suppressCutToClipboard} />
```

This is demonstrated in the example below. Note the following:

- Selecting a cell and pressing `^ Ctrl`+`X` will not `copy` or `cut` the data.
- The context menu will not show an option to `Cut`.

#### Clipboard Suppress Cut

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  CellSelectionOptions,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

const modules = [
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "athlete", minWidth: 200 },
    { field: "age" },
    { field: "country", minWidth: 150 },
    { field: "year" },
    { field: "date", minWidth: 150 },
    { field: "sport", minWidth: 150 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      editable: true,
      flex: 1,
      minWidth: 100,
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<IOlympicData>
            rowData={data}
            loading={loading}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            cellSelection={true}
            suppressCutToClipboard={true}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Clipboard Suppress Cut](https://www.ag-grid.com/examples/clipboard/suppress-cut/reactFunctionalTs)

## How to Paste

Paste is enabled by default in the enterprise version and is possible as long as the cells you're pasting into are [editable](https://www.ag-grid.com/react-data-grid/cell-editing/) (non-editable cells cannot be modified, even with a paste operation). You can paste using the keybind `^ Ctrl`+`V` while focus is on the grid.

The behaviour of paste changes depending on whether you have a single cell or a range selected:

- When a **single cell is selected**. The paste will proceed starting at the selected cell if multiple cells are to be pasted.
- When a **range of cells selected**. If the selected range being pasted is larger than copied range, it will repeat if it fits evenly, otherwise it will just copy the cells into the start of the range.

## Disabling Paste

You can turn paste operations off for the entire grid, by setting the grid property `suppressClipboardPaste=true`.

Or you can disable pasting for a specific column or cell by setting the property `suppressPaste` on the column definition. This can be a boolean or a function (use a function to specify for a particular cell, or boolean for the whole column).

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `suppressPaste` | `boolean \| SuppressPasteCallback` |  |  | Pasting is on by default as long as cells are editable (non-editable cells cannot be modified, even with a paste operation). Set to `true` turn paste operations off. |

## Processing Pasted Data

The clipboard data will be processed by default [Using the Value Formatter for Export](https://www.ag-grid.com/react-data-grid/value-formatters/#formatting-for-export) to format the cells when copied, and [Using the Value Parser for Import](https://www.ag-grid.com/react-data-grid/value-parsers/#use-value-parser-for-import) to format the cells when pasted.

It is possible to override this behaviour specifically for the clipboard. This can be done either on individual cells or the whole paste operation.

### Processing Individual Cells

The interfaces and parameters for processing individual cells are as follows:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `processCellForClipboard` | `ProcessCellForClipboard` |  |  | Allows you to process cells for the clipboard. Handy if for example you have `Date` objects that need to have a particular format if importing into Excel. Module: [`ClipboardModule`](https://www.ag-grid.com/react-data-grid/modules/). |
| `processHeaderForClipboard` | `ProcessHeaderForClipboard` |  |  | Allows you to process header values for the clipboard. Module: [`ClipboardModule`](https://www.ag-grid.com/react-data-grid/modules/). |
| `processGroupHeaderForClipboard` | `ProcessGroupHeaderForClipboard` |  |  | Allows you to process group header values for the clipboard. Module: [`ClipboardModule`](https://www.ag-grid.com/react-data-grid/modules/). |
| `processCellFromClipboard` | `ProcessCellFromClipboard` |  |  | Allows you to process cells from the clipboard. Handy if for example you have number fields and want to block non-numbers from getting into the grid. Module: [`ClipboardModule`](https://www.ag-grid.com/react-data-grid/modules/). |

These three callbacks above are demonstrated in the example below. Note the following:

- When cells are copied to the clipboard, values are prefixed with 'C-'. Cells can be copied by dragging a range with the mouse and hitting `^ Ctrl`+`C`.
- When cells are pasted from the clipboard, values are prefixed with 'Z-'. Cells can be pasted by hitting `^ Ctrl`+`V`.
- When headers are copied to the clipboard, values are prefixed with 'H-'. Headers can be copied by using the context menu.
- When group headers are copied to the clipboard, values are prefixed with 'GH-'. Headers can be copied by using the context menu.

#### Example Process

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  CellSelectionOptions,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  ProcessCellForClipboard,
  ProcessCellForExportParams,
  ProcessCellFromClipboard,
  ProcessGroupHeaderForClipboard,
  ProcessGroupHeaderForExportParams,
  ProcessHeaderForClipboard,
  ProcessHeaderForExportParams,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

const modules = [
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<(ColDef | ColGroupDef)[]>([
    {
      headerName: "Participants",
      children: [
        { field: "athlete", headerName: "Athlete Name", minWidth: 200 },
        { field: "age" },
        { field: "country", minWidth: 150 },
      ],
    },
    {
      headerName: "Olympic Games",
      children: [
        { field: "year" },
        { field: "date", minWidth: 150 },
        { field: "sport", minWidth: 150 },
        { field: "gold" },
        { field: "silver", suppressPaste: true },
        { field: "bronze" },
        { field: "total" },
      ],
    },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      editable: true,
      flex: 1,
      minWidth: 100,
      cellDataType: false,
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  const processCellForClipboard = useCallback(
    (params: ProcessCellForExportParams) => {
      return "C-" + params.value;
    },
    [],
  );

  const processHeaderForClipboard = useCallback(
    (params: ProcessHeaderForExportParams) => {
      const colDef = params.column.getColDef();
      let headerName = colDef.headerName || colDef.field || "";
      if (colDef.headerName !== "") {
        headerName = headerName.charAt(0).toUpperCase() + headerName.slice(1);
      }
      return "H-" + headerName;
    },
    [],
  );

  const processGroupHeaderForClipboard = useCallback(
    (params: ProcessGroupHeaderForExportParams) => {
      const colGroupDef = params.columnGroup.getColGroupDef() || ({} as any);
      const headerName = colGroupDef.headerName || "";
      if (headerName === "") {
        return "";
      }
      return "GH-" + headerName;
    },
    [],
  );

  const processCellFromClipboard = useCallback(
    (params: ProcessCellForExportParams) => {
      return "Z-" + params.value;
    },
    [],
  );

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<IOlympicData>
            rowData={data}
            loading={loading}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            cellSelection={true}
            processCellForClipboard={processCellForClipboard}
            processHeaderForClipboard={processHeaderForClipboard}
            processGroupHeaderForClipboard={processGroupHeaderForClipboard}
            processCellFromClipboard={processCellFromClipboard}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Example Process](https://www.ag-grid.com/examples/clipboard/process/reactFunctionalTs)

### Processing Data from Clipboard

To have complete control of processing clipboard data when pasting, you can use the callback below:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `processDataFromClipboard` | `ProcessDataFromClipboard` |  |  | Allows complete control of the paste operation, including cancelling the operation (so nothing happens) or replacing the data with other data. Module: [`ClipboardModule`](https://www.ag-grid.com/react-data-grid/modules/). |

The following example shows custom code to process the data from the clipboard:

- The cells are coloured based on the colour that the cell content starts with
- Copy a cell range in the grid which includes a cell value that starts with `Red`. Pasting into the grid will paste a custom 4x4 cell grid.
- Copy a cell range in the grid which includes a cell value that starts with `Yellow` and **doesn’t** include any `Red` cell values. Pasting this copied cell range will cancel the paste action and not paste anything
- Any other copied cell data will be pasted as-is

#### Example Process Data

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./style.css";
import {
  CellSelectionOptions,
  CellStyleModule,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  ProcessDataFromClipboard,
  ProcessDataFromClipboardParams,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
import { getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

const modules = [
  TextEditorModule,
  CellStyleModule,
  ClientSideRowModelModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<any[]>(getData());
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "a" },
    { field: "b" },
    { field: "c" },
    { field: "d" },
    { field: "e" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      editable: true,
      minWidth: 120,
      flex: 1,
      cellClassRules: {
        "cell-green": 'value && value.startsWith("Green")',
        "cell-blue": 'value && value.startsWith("Blue")',
        "cell-red": 'value && value.startsWith("Red")',
        "cell-yellow": 'value && value.startsWith("Yellow")',
      },
    };
  }, []);

  const processDataFromClipboard = useCallback(
    (params: ProcessDataFromClipboardParams): string[][] | null => {
      let containsRed;
      let containsYellow;
      const data = params.data;
      for (let i = 0; i < data.length; i++) {
        const row = data[i];
        for (let j = 0; j < row.length; j++) {
          const value = row[j];
          if (value) {
            if (value.startsWith("Red")) {
              containsRed = true;
            } else if (value.startsWith("Yellow")) {
              containsYellow = true;
            }
          }
        }
      }
      if (containsRed) {
        // replace the paste request with another
        return [
          ["Custom 1", "Custom 2"],
          ["Custom 3", "Custom 4"],
        ];
      }
      if (containsYellow) {
        // cancels the paste
        return null;
      }
      return data;
    },
    [],
  );

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact
            rowData={rowData}
            columnDefs={columnDefs}
            cellSelection={true}
            defaultColDef={defaultColDef}
            processDataFromClipboard={processDataFromClipboard}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Example Process Data](https://www.ag-grid.com/examples/clipboard/process-all/reactFunctionalTs)

### Pasting New Rows at the Bottom of the Grid

By default, when pasting multiple rows near the last record shown in the grid, any rows exceeding the total number of rows shown in the grid will not be pasted.

In order to insert all the copied rows in the grid, a custom `processDataFromClipboard` function is needed to add the necessary number of new rows using the [Transaction Update API](https://www.ag-grid.com/react-data-grid/data-update-transactions/#transaction-update-api).

The example below uses a custom `processDataFromClipboard` function to add new rows to the grid, to fit all the copied rows:

- Select the top 3 rows in the grid using `⇧ Shift` + click
- Press `^ Ctrl`+`C` to copy the selected rows
- Select the `Ryan Lochte` cell on the last row and press `^ Ctrl`+`V` to paste the copied rows
- Notice that the `Ryan Lochte` row has been overwritten and 2 extra rows are created at the bottom of the grid to accommodate the additional 2 rows pasted

#### Paste New Rows

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ColumnApiModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  ProcessDataFromClipboard,
  ProcessDataFromClipboardParams,
  RowApiModule,
  RowSelectionModule,
  RowSelectionOptions,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

const modules = [
  ColumnApiModule,
  RowApiModule,
  ClientSideRowModelApiModule,
  NumberEditorModule,
  TextEditorModule,
  RowSelectionModule,
  ClientSideRowModelModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { headerName: "Athlete", field: "athlete", width: 150 },
    { headerName: "Age", field: "age", width: 90 },
    { headerName: "Country", field: "country", width: 120 },
    { headerName: "Year", field: "year", width: 90 },
    { headerName: "Date", field: "date", width: 110 },
    { headerName: "Sport", field: "sport", width: 110 },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      editable: true,
    };
  }, []);
  const rowSelection = useMemo<
    RowSelectionOptions | "single" | "multiple"
  >(() => {
    return {
      mode: "multiRow",
      checkboxes: false,
      headerCheckbox: false,
      enableClickSelection: true,
      copySelectedRows: true,
    };
  }, []);

  const { data, loading } = useFetchJson<any>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
    8,
  );

  const processDataFromClipboard = useCallback(
    (params: ProcessDataFromClipboardParams): string[][] | null => {
      const data = [...params.data];
      const emptyLastRow =
        data[data.length - 1][0] === "" && data[data.length - 1].length === 1;
      if (emptyLastRow) {
        data.splice(data.length - 1, 1);
      }
      const lastIndex = params.api!.getDisplayedRowCount() - 1;
      const focusedCell = params.api!.getFocusedCell();
      const focusedIndex = focusedCell!.rowIndex;
      if (focusedIndex + data.length - 1 > lastIndex) {
        const resultLastIndex = focusedIndex + (data.length - 1);
        const numRowsToAdd = resultLastIndex - lastIndex;
        const rowsToAdd: any[] = [];
        for (let i = 0; i < numRowsToAdd; i++) {
          const index = data.length - 1;
          const row = data.slice(index, index + 1)[0];
          // Create row object
          const rowObject: any = {};
          let currentColumn: any = focusedCell!.column;
          row.forEach((item) => {
            if (!currentColumn) {
              return;
            }
            rowObject[currentColumn.colDef.field] = item;
            currentColumn = params.api!.getDisplayedColAfter(currentColumn);
          });
          rowsToAdd.push(rowObject);
        }
        params.api!.applyTransaction({ add: rowsToAdd });
      }
      return data;
    },
    [],
  );

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact
            rowData={data}
            loading={loading}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            rowSelection={rowSelection}
            processDataFromClipboard={processDataFromClipboard}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Paste New Rows](https://www.ag-grid.com/examples/clipboard/pasting-extra-rows/reactFunctionalTs)

### Read Only Edit

When the grid is in [Read Only Edit](https://www.ag-grid.com/react-data-grid/value-setters/#read-only-edit) mode the `Clipboard` will not update the data inside the grid. Instead the grid fires `cellEditRequest` events allowing the application to process the update request.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `cellEditRequest` | `CellEditRequestEvent` |  |  | Value has changed after editing. Only fires when `readOnlyEdit=true`. |

The example below will show how to update cell value combining the `Clipboard` with `readOnlyEdit=true`.

#### Clipboard - ReadOnlyEdit

```tsx
("use client");

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  CellEditRequestEvent,
  CellSelectionOptions,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GetRowIdFunc,
  GetRowIdParams,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import { CellSelectionModule, ClipboardModule } from "ag-grid-enterprise";
import { IOlympicDataWithId } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

const modules = [
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelModule,
  ClipboardModule,
  CellSelectionModule,
];

let rowImmutableStore: any[];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<IOlympicDataWithId[]>();
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "athlete", minWidth: 160 },
    { field: "age" },
    { field: "country", minWidth: 140 },
    { field: "year" },
    { field: "date", minWidth: 140 },
    { field: "sport", minWidth: 160 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      minWidth: 100,
      editable: true,
    };
  }, []);
  const getRowId = useCallback(
    (params: GetRowIdParams) => String(params.data.id),
    [],
  );

  const onGridReady = useCallback((params: GridReadyEvent) => {
    fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .then((resp) => resp.json())
      .then((data: IOlympicDataWithId[]) => {
        data.forEach((item, index) => (item.id = index));
        rowImmutableStore = data;
        setRowData(rowImmutableStore);
      });
  }, []);

  const onCellEditRequest = useCallback(
    (event: CellEditRequestEvent) => {
      const data = event.data;
      const field = event.colDef.field;
      const newValue = event.newValue;
      const oldItem = rowImmutableStore.find((row) => row.id === data.id);
      if (!oldItem || !field) {
        return;
      }
      const newItem = { ...oldItem };
      newItem[field] = newValue;
      console.log("onCellEditRequest, updating " + field + " to " + newValue);
      rowImmutableStore = rowImmutableStore.map((oldItem) =>
        oldItem.id == newItem.id ? newItem : oldItem,
      );
      setRowData(rowImmutableStore);
    },
    [rowImmutableStore],
  );

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<IOlympicDataWithId>
            rowData={rowData}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            getRowId={getRowId}
            cellSelection={true}
            readOnlyEdit={true}
            onGridReady={onGridReady}
            onCellEditRequest={onCellEditRequest}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Clipboard - ReadOnlyEdit](https://www.ag-grid.com/examples/clipboard/read-only-edit/reactFunctionalTs)

## Changing the Delimiter for Copy & Paste

By default, the grid will use `\t` (tab) as the field delimiter. This is to keep the copy / paste compatible with Excel. If you want another delimiter then you can set the property `gridOptions.clipboardDelimiter` to a value of your choosing.

## Using the Browser's Text Selection

The grid's selection and copy features replace the built-in browser behaviour for selecting and copying text. If you want to use the normal browser behaviour instead, you should set `enableCellTextSelection=true` in the gridOptions. Note the following:

- When `enableCellTextSelection=true`, pressing `^ Ctrl`+`C` doesn’t copy the focused cell value, but only the selected text inside the grid cell. When using AG Grid Enterprise, the user can copy the entire cell value by right-clicking the grid cell to show the [context menu](https://www.ag-grid.com/react-data-grid/context-menu/) and clicking the any of the Copy menu items.
- When `enableCellTextSelection=true`, the option `ensureDomOrder=true` needs to be set for correct accessibility support. See [Ensure DOM Element order](https://www.ag-grid.com/react-data-grid/accessibility/#ensure-dom-element-order).

> **Note**
>
> This is not an enterprise config and can be used at any time to enable cell text selection.

See this behaviour shown in the example below:

- Focus a grid cell and press `^ Ctrl`+`C`. The cell value will not be copied because no text is selected.
- Click a cell and drag across its value to select the text. Press `^ Ctrl`+`C` and the value will be copied.
- This sample is using AG Grid Community version, so the context menu is not available to copy the focused cell value. In AG Grid Enterprise the context menu will be available to copy the entire focused cell value without having to select it as text.

#### Using Browser text selection

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

const modules = [
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelModule,
];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "athlete", minWidth: 200 },
    { field: "age" },
    { field: "country", minWidth: 150 },
    { field: "year" },
    { field: "date", minWidth: 150 },
    { field: "sport", minWidth: 150 },
    { field: "gold" },
    { field: "silver", suppressPaste: true },
    { field: "bronze" },
    { field: "total" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      editable: true,
      flex: 1,
      minWidth: 100,
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<IOlympicData>
            rowData={data}
            loading={loading}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            ensureDomOrder={true}
            enableCellTextSelection={true}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Using Browser text selection](https://www.ag-grid.com/examples/clipboard/cellTextSelection/reactFunctionalTs)

## Clipboard Events

The following events are relevant to clipboard operations:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `cutStart` | `CutStartEvent` |  |  | Cut operation has started. |
| `cutEnd` | `CutEndEvent` |  |  | Cut operation has ended. |
| `pasteStart` | `PasteStartEvent` |  |  | Paste operation has started. |
| `pasteEnd` | `PasteEndEvent` |  |  | Paste operation has ended. |

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `cellValueChanged` | `CellValueChangedEvent` |  |  | Cell value has changed. This occurs after the following scenarios: - Editing. Will not fire if any of the following are true: new value is the same as old value; `readOnlyEdit = true`; editing was cancelled (e.g. Escape key was pressed); or new value is of the wrong cell data type for the column. - Cut. - Paste. - Cell clear (pressing Delete key). - Fill handle. - Copy range down. - Undo and redo. See [Editing Events](https://www.ag-grid.com/react-data-grid/cell-editing/#editing-events) for more information. |

For a cut or paste operation the events will be fired as:

1. One `cutStart`/`pasteStart` event.
2. Many `cellValueChanged` events.
3. One `cutEnd`/`pasteEnd` event.

If the application is doing work each time it receives a `cellValueChanged`, you can use the `cutStart`/`pasteStart` and `cutEnd`/`pasteEnd` events to suspend the applications work and then do the work for all cells impacted by the cut/paste operation after the cut/paste operation.

There are no events triggered by copy to clipboard as this does not change the grid's data.

#### Clipboard Events

```tsx
("use client");

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  CellSelectionOptions,
  CellValueChangedEvent,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  CutEndEvent,
  CutStartEvent,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberEditorModule,
  PasteEndEvent,
  PasteStartEvent,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

const modules = [
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "athlete", minWidth: 200 },
    { field: "age" },
    { field: "country", minWidth: 150 },
    { field: "year" },
    { field: "date", minWidth: 150 },
    { field: "sport", minWidth: 150 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      editable: true,
      flex: 1,
      minWidth: 100,
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  const onCellValueChanged = useCallback((params: CellValueChangedEvent) => {
    console.log("Callback onCellValueChanged:", params);
  }, []);

  const onCutStart = useCallback((params: CutStartEvent) => {
    console.log("Callback onCutStart:", params);
  }, []);

  const onCutEnd = useCallback((params: CutEndEvent) => {
    console.log("Callback onCutEnd:", params);
  }, []);

  const onPasteStart = useCallback((params: PasteStartEvent) => {
    console.log("Callback onPasteStart:", params);
  }, []);

  const onPasteEnd = useCallback((params: PasteEndEvent) => {
    console.log("Callback onPasteEnd:", params);
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<IOlympicData>
            rowData={data}
            loading={loading}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            cellSelection={true}
            onCellValueChanged={onCellValueChanged}
            onCutStart={onCutStart}
            onCutEnd={onCutEnd}
            onPasteStart={onPasteStart}
            onPasteEnd={onPasteEnd}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Clipboard Events](https://www.ag-grid.com/examples/clipboard/clipboard-events/reactFunctionalTs)


---
product: "AG Grid"
title: "Clipboard"
description: "You can copy and paste items to and from the grid using the system clipboard."
enterprise: true
framework: vue
version: "36.2.0"
related:
    - title: "CSV Export"
      url: "https://www.ag-grid.com/vue-data-grid/csv-export/"
    - title: "Excel Export"
      url: "https://www.ag-grid.com/vue-data-grid/excel-export/"
    - title: "Excel Import"
      url: "https://www.ag-grid.com/vue-data-grid/excel-import/"
    - title: "PDF Export"
      url: "https://www.ag-grid.com/vue-data-grid/pdf-export/"
    - title: "Drag & Drop"
      url: "https://www.ag-grid.com/vue-data-grid/drag-and-drop/"
    - title: "Printing"
      url: "https://www.ag-grid.com/vue-data-grid/printing/"
llms: "https://www.ag-grid.com/llms.txt"
---

# Clipboard

You can copy and paste items to and from the grid using the system clipboard.

## How to copy

Copying from the grid is **enabled by default** for enterprise users. To copy your selection to the system clipboard, you can use the keybind `^ Ctrl`+`C`, or right click on a cell and select 'Copy' from the context menu. Unless [Cell Selection](https://www.ag-grid.com/vue-data-grid/cell-selection/) or [Row Selection](https://www.ag-grid.com/vue-data-grid/row-selection/) is enabled, you will only be copying from the currently focused cell.

When copying multiple cells, the contents will be copied in an Excel compatible format, with fields separated by a `\t` (tab) character.

## Copying Cell Ranges

When [Cell Ranges](https://www.ag-grid.com/vue-data-grid/cell-selection/) are enabled by setting `gridOptions.cellSelection=true`, copying will copy the Cell Range's content to your clipboard. Select a range by clicking on a cell and dragging with the mouse, then copy with the `^ Ctrl`+`C` keybind.

Multiple cell ranges can be selected at once using `^ Ctrl` and dragging with the mouse. When copying, all ranges will be copied to the clipboard. Note that the relative positions of multiple ranges is not preserved when copying, they are stacked vertically in the clipboard.

In the below example try:

- Select a cell range with click & drag
- Copy with `^ Ctrl`+`C`
- Paste into an external program / text editor.

#### Copying Cell Ranges

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  CellSelectionOptions,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :cellSelection="true"
      :rowData="rowData"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "athlete", minWidth: 200 },
      { field: "age" },
      { field: "country", minWidth: 150 },
      { field: "year" },
      { field: "date", minWidth: 150 },
      { field: "sport", minWidth: 150 },
      { field: "gold" },
      { field: "silver" },
      { field: "bronze" },
      { field: "total" },
    ]);
    const defaultColDef = ref<ColDef>({
      editable: true,
      flex: 1,
      minWidth: 100,
    });
    const rowData = ref<IOlympicData[]>(null);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data);

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      rowData,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Copying Cell Ranges](https://www.ag-grid.com/examples/clipboard/copy-range/vue3/)

## Copying Rows

When [Row Selection](https://www.ag-grid.com/vue-data-grid/row-selection/) is enabled by setting `gridOptions.rowSelection.mode` to either `"singleRow"` or `"multiRow"`, the default behaviour is to copy only the focused cell to the clipboard. In order to copy the whole row, enable the `gridOptions.rowSelection.copySelectedRows` flag.

```ts
<ag-grid-vue
    :rowSelection="rowSelection"
    /* other grid options ... */>
</ag-grid-vue>

this.rowSelection = {
    mode: 'multiRow',
    copySelectedRows: true,
};
```

The below example demonstrates copying rows. Initially, pressing `^ Ctrl`+C will select the focused cell, regardless of which rows have been selected. You can change this behaviour by toggling the "Copy Selected Rows" checkbox to enable the `copySelectedRows` flag:

- Toggle the "Copy Selected Rows" checkbox on
- Select one or more rows in the example below and press `^ Ctrl`+C
- Paste copied content in a text editor
- When the "Copy Selected Rows" checkbox is toggled on, the pasted content includes all selected rows. When the "Copy Selected Rows" checkbox is toggled off, the pasted content includes only the focussed cell.

#### Copying Rows

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./style.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  RowSelectionModule,
  RowSelectionOptions,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
  RowSelectionModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div class="example-wrapper">
      <div class="example-header">
        <label for="toggle-copy-rows">Copy Selected Rows: </label>
        <input type="checkbox" id="toggle-copy-rows" v-on:change="toggleCopyRows()">
        </div>
        <ag-grid-vue
          style="width: 100%; height: 100%;"
          @grid-ready="onGridReady"
          :columnDefs="columnDefs"
          :defaultColDef="defaultColDef"
          :rowSelection="rowSelection"
          :rowData="rowData"></ag-grid-vue>
        </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "athlete", minWidth: 200 },
      { field: "age" },
      { field: "country", minWidth: 150 },
      { field: "year" },
      { field: "date", minWidth: 150 },
      { field: "sport", minWidth: 150 },
      { field: "gold" },
      { field: "silver" },
      { field: "bronze" },
      { field: "total" },
    ]);
    const defaultColDef = ref<ColDef>({
      editable: true,
      flex: 1,
      minWidth: 100,
    });
    const rowSelection = ref<RowSelectionOptions | "single" | "multiple">({
      mode: "multiRow",
      copySelectedRows: false,
    });
    const rowData = ref<IOlympicData[]>(null);

    function toggleCopyRows() {
      gridApi.value.setGridOption("rowSelection", {
        mode: "multiRow",
        copySelectedRows:
          document.querySelector<HTMLInputElement>("#toggle-copy-rows")
            ?.checked ?? false,
      });
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data);

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      rowSelection,
      rowData,
      onGridReady,
      toggleCopyRows,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Copying Rows](https://www.ag-grid.com/examples/clipboard/copy-row/vue3/)

## Copying Headers

The column headers can be copied to the clipboard in addition to the cell contents by enabling the option `copyHeadersToClipboard`.

```ts
<ag-grid-vue
    :copyHeadersToClipboard="copyHeadersToClipboard"
    /* other grid options ... */>
</ag-grid-vue>

this.copyHeadersToClipboard = true;
```

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `copyHeadersToClipboard` | `boolean` |  |  |  |

In the below example try:

- Select a cell range with click & drag
- Copy with `^ Ctrl`+`C`
- Paste into an external program / text editor, note that the column headers were also copied.

#### Copying Cell Ranges and Headers

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  CellSelectionOptions,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :cellSelection="true"
      :copyHeadersToClipboard="true"
      :rowData="rowData"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "athlete", minWidth: 200 },
      { field: "age" },
      { field: "country", minWidth: 150 },
      { field: "year" },
      { field: "date", minWidth: 150 },
      { field: "sport", minWidth: 150 },
      { field: "gold" },
      { field: "silver" },
      { field: "bronze" },
      { field: "total" },
    ]);
    const defaultColDef = ref<ColDef>({
      editable: true,
      flex: 1,
      minWidth: 100,
    });
    const rowData = ref<IOlympicData[]>(null);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data);

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      rowData,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Copying Cell Ranges and Headers](https://www.ag-grid.com/examples/clipboard/copy-range-with-headers/vue3/)

## Custom Clipboard Interaction

If you want to do the copy to clipboard yourself (i.e. not use the grid's clipboard interaction) then implement the callback `sendToClipboard(params)`. Use this if you are in a non-standard web container that has a bespoke API for interacting with the clipboard. The callback gets the data to go into the clipboard, it's your job to call the bespoke API.

The example below shows using `sendToClipboard(params)`, but rather than using the clipboard, demonstrates the callback by just printing the data to the console.

#### Controlling Clipboard Copy

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  CellSelectionOptions,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  RowSelectionModule,
  RowSelectionOptions,
  SendToClipboard,
  SendToClipboardParams,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  RowSelectionModule,
  ClientSideRowModelModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div style="display: flex; height: 100%; flex-direction: column">
      <div style="padding-bottom: 5px">
        <button v-on:click="onBtCopyRows()">Copy Selected Rows to Clipboard</button>
        <button v-on:click="onBtCopyRange()">Copy Selected Range to Clipboard</button>
      </div>
      <ag-grid-vue
        style="width: 100%; height: 100%;"
        @grid-ready="onGridReady"
        :columnDefs="columnDefs"
        :defaultColDef="defaultColDef"
        :cellSelection="true"
        :rowSelection="rowSelection"
        :sendToClipboard="sendToClipboard"
        :rowData="rowData"></ag-grid-vue>
      </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "athlete", minWidth: 200 },
      { field: "age" },
      { field: "country", minWidth: 150 },
      { field: "year" },
      { field: "date", minWidth: 150 },
      { field: "sport", minWidth: 150 },
      { field: "gold" },
      { field: "silver" },
      { field: "bronze" },
      { field: "total" },
    ]);
    const defaultColDef = ref<ColDef>({
      editable: true,
      flex: 1,
      minWidth: 100,
    });
    const rowSelection = ref<RowSelectionOptions | "single" | "multiple">({
      mode: "multiRow",
    });
    const rowData = ref<IOlympicData[]>(null);

    function onBtCopyRows() {
      gridApi.value!.copySelectedRowsToClipboard();
    }
    function onBtCopyRange() {
      gridApi.value!.copySelectedRangeToClipboard();
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data);

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };
    function sendToClipboard(params: SendToClipboardParams) {
      console.log("send to clipboard called with data:");
      console.log(params.data);
    }

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      rowSelection,
      sendToClipboard,
      rowData,
      onGridReady,
      onBtCopyRows,
      onBtCopyRange,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Controlling Clipboard Copy](https://www.ag-grid.com/examples/clipboard/custom/vue3/)

## Copying via the API

You can use the Grid API methods: `copySelectedRowsToClipboard(...)` and `copySelectedRangeToClipboard(...)` to copy rows or ranges respectively, these API calls take optional parameters to enable copying column and group headers.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `copySelectedRangeToClipboard` | `Function` |  |  |  |
| `copySelectedRowsToClipboard` | `Function` |  |  |  |

## How to Cut

Cut from the grid is **enabled by default** for enterprise users. To cut your selection to the system clipboard, you can use the keybind `^ Ctrl`+`X`, or right click on a cell and select 'Cut' from the context menu. Unless [Range Selection](https://www.ag-grid.com/vue-data-grid/cell-selection/) or [Row Selection](https://www.ag-grid.com/vue-data-grid/row-selection/) is enabled, you will only be copying from the currently focused cell.

The cut operations will work exactly the same as the copy operations, with the addition that data will be removed from the grid afterwards, so the cut operations will use the same properties described above to customise the `copy` process.

## Disabling Cut

Since `Cut` is a destructive process, the `suppressCutToClipboard` property was added to the Grid Options.

```ts
<ag-grid-vue
    :suppressCutToClipboard="suppressCutToClipboard"
    /* other grid options ... */>
</ag-grid-vue>

this.suppressCutToClipboard = true;
```

This is demonstrated in the example below. Note the following:

- Selecting a cell and pressing `^ Ctrl`+`X` will not `copy` or `cut` the data.
- The context menu will not show an option to `Cut`.

#### Clipboard Suppress Cut

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  CellSelectionOptions,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :cellSelection="true"
      :suppressCutToClipboard="true"
      :rowData="rowData"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "athlete", minWidth: 200 },
      { field: "age" },
      { field: "country", minWidth: 150 },
      { field: "year" },
      { field: "date", minWidth: 150 },
      { field: "sport", minWidth: 150 },
      { field: "gold" },
      { field: "silver" },
      { field: "bronze" },
      { field: "total" },
    ]);
    const defaultColDef = ref<ColDef>({
      editable: true,
      flex: 1,
      minWidth: 100,
    });
    const rowData = ref<IOlympicData[]>(null);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data);

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      rowData,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Clipboard Suppress Cut](https://www.ag-grid.com/examples/clipboard/suppress-cut/vue3/)

## How to Paste

Paste is enabled by default in the enterprise version and is possible as long as the cells you're pasting into are [editable](https://www.ag-grid.com/vue-data-grid/cell-editing/) (non-editable cells cannot be modified, even with a paste operation). You can paste using the keybind `^ Ctrl`+`V` while focus is on the grid.

The behaviour of paste changes depending on whether you have a single cell or a range selected:

- When a **single cell is selected**. The paste will proceed starting at the selected cell if multiple cells are to be pasted.
- When a **range of cells selected**. If the selected range being pasted is larger than copied range, it will repeat if it fits evenly, otherwise it will just copy the cells into the start of the range.

## Disabling Paste

You can turn paste operations off for the entire grid, by setting the grid property `suppressClipboardPaste=true`.

Or you can disable pasting for a specific column or cell by setting the property `suppressPaste` on the column definition. This can be a boolean or a function (use a function to specify for a particular cell, or boolean for the whole column).

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `suppressPaste` | `boolean \| SuppressPasteCallback` |  |  |  |

## Processing Pasted Data

The clipboard data will be processed by default [Using the Value Formatter for Export](https://www.ag-grid.com/vue-data-grid/value-formatters/#formatting-for-export) to format the cells when copied, and [Using the Value Parser for Import](https://www.ag-grid.com/vue-data-grid/value-parsers/#use-value-parser-for-import) to format the cells when pasted.

It is possible to override this behaviour specifically for the clipboard. This can be done either on individual cells or the whole paste operation.

### Processing Individual Cells

The interfaces and parameters for processing individual cells are as follows:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `processCellForClipboard` | `ProcessCellForClipboard` |  |  |  |
| `processHeaderForClipboard` | `ProcessHeaderForClipboard` |  |  |  |
| `processGroupHeaderForClipboard` | `ProcessGroupHeaderForClipboard` |  |  |  |
| `processCellFromClipboard` | `ProcessCellFromClipboard` |  |  |  |

These three callbacks above are demonstrated in the example below. Note the following:

- When cells are copied to the clipboard, values are prefixed with 'C-'. Cells can be copied by dragging a range with the mouse and hitting `^ Ctrl`+`C`.
- When cells are pasted from the clipboard, values are prefixed with 'Z-'. Cells can be pasted by hitting `^ Ctrl`+`V`.
- When headers are copied to the clipboard, values are prefixed with 'H-'. Headers can be copied by using the context menu.
- When group headers are copied to the clipboard, values are prefixed with 'GH-'. Headers can be copied by using the context menu.

#### Example Process

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  CellSelectionOptions,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  ProcessCellForClipboard,
  ProcessCellForExportParams,
  ProcessCellFromClipboard,
  ProcessGroupHeaderForClipboard,
  ProcessGroupHeaderForExportParams,
  ProcessHeaderForClipboard,
  ProcessHeaderForExportParams,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :cellSelection="true"
      :processCellForClipboard="processCellForClipboard"
      :processHeaderForClipboard="processHeaderForClipboard"
      :processGroupHeaderForClipboard="processGroupHeaderForClipboard"
      :processCellFromClipboard="processCellFromClipboard"
      :rowData="rowData"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<(ColDef | ColGroupDef)[]>([
      {
        headerName: "Participants",
        children: [
          { field: "athlete", headerName: "Athlete Name", minWidth: 200 },
          { field: "age" },
          { field: "country", minWidth: 150 },
        ],
      },
      {
        headerName: "Olympic Games",
        children: [
          { field: "year" },
          { field: "date", minWidth: 150 },
          { field: "sport", minWidth: 150 },
          { field: "gold" },
          { field: "silver", suppressPaste: true },
          { field: "bronze" },
          { field: "total" },
        ],
      },
    ]);
    const defaultColDef = ref<ColDef>({
      editable: true,
      flex: 1,
      minWidth: 100,
      cellDataType: false,
    });
    const rowData = ref<IOlympicData[]>(null);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data);

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };
    function processCellForClipboard(params: ProcessCellForExportParams) {
      return "C-" + params.value;
    }
    function processHeaderForClipboard(params: ProcessHeaderForExportParams) {
      const colDef = params.column.getColDef();
      let headerName = colDef.headerName || colDef.field || "";
      if (colDef.headerName !== "") {
        headerName = headerName.charAt(0).toUpperCase() + headerName.slice(1);
      }
      return "H-" + headerName;
    }
    function processGroupHeaderForClipboard(
      params: ProcessGroupHeaderForExportParams,
    ) {
      const colGroupDef = params.columnGroup.getColGroupDef() || ({} as any);
      const headerName = colGroupDef.headerName || "";
      if (headerName === "") {
        return "";
      }
      return "GH-" + headerName;
    }
    function processCellFromClipboard(params: ProcessCellForExportParams) {
      return "Z-" + params.value;
    }

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      processCellForClipboard,
      processHeaderForClipboard,
      processGroupHeaderForClipboard,
      processCellFromClipboard,
      rowData,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Example Process](https://www.ag-grid.com/examples/clipboard/process/vue3/)

### Processing Data from Clipboard

To have complete control of processing clipboard data when pasting, you can use the callback below:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `processDataFromClipboard` | `ProcessDataFromClipboard` |  |  |  |

The following example shows custom code to process the data from the clipboard:

- The cells are coloured based on the colour that the cell content starts with
- Copy a cell range in the grid which includes a cell value that starts with `Red`. Pasting into the grid will paste a custom 4x4 cell grid.
- Copy a cell range in the grid which includes a cell value that starts with `Yellow` and **doesn’t** include any `Red` cell values. Pasting this copied cell range will cancel the paste action and not paste anything
- Any other copied cell data will be pasted as-is

#### Example Process Data

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./style.css";
import {
  CellSelectionOptions,
  CellStyleModule,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  ProcessDataFromClipboard,
  ProcessDataFromClipboardParams,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
import { getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  TextEditorModule,
  CellStyleModule,
  ClientSideRowModelModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :rowData="rowData"
      :cellSelection="true"
      :defaultColDef="defaultColDef"
      :processDataFromClipboard="processDataFromClipboard"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "a" },
      { field: "b" },
      { field: "c" },
      { field: "d" },
      { field: "e" },
    ]);
    const rowData = ref<any[] | null>(getData());
    const defaultColDef = ref<ColDef>({
      editable: true,
      minWidth: 120,
      flex: 1,
      cellClassRules: {
        "cell-green": 'value && value.startsWith("Green")',
        "cell-blue": 'value && value.startsWith("Blue")',
        "cell-red": 'value && value.startsWith("Red")',
        "cell-yellow": 'value && value.startsWith("Yellow")',
      },
    });

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;
    };
    const processDataFromClipboard: (
      params: ProcessDataFromClipboardParams,
    ) => string[][] | null = (params: ProcessDataFromClipboardParams) => {
      let containsRed;
      let containsYellow;
      const data = params.data;
      for (let i = 0; i < data.length; i++) {
        const row = data[i];
        for (let j = 0; j < row.length; j++) {
          const value = row[j];
          if (value) {
            if (value.startsWith("Red")) {
              containsRed = true;
            } else if (value.startsWith("Yellow")) {
              containsYellow = true;
            }
          }
        }
      }
      if (containsRed) {
        // replace the paste request with another
        return [
          ["Custom 1", "Custom 2"],
          ["Custom 3", "Custom 4"],
        ];
      }
      if (containsYellow) {
        // cancels the paste
        return null;
      }
      return data;
    };

    return {
      gridApi,
      columnDefs,
      rowData,
      defaultColDef,
      processDataFromClipboard,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Example Process Data](https://www.ag-grid.com/examples/clipboard/process-all/vue3/)

### Pasting New Rows at the Bottom of the Grid

By default, when pasting multiple rows near the last record shown in the grid, any rows exceeding the total number of rows shown in the grid will not be pasted.

In order to insert all the copied rows in the grid, a custom `processDataFromClipboard` function is needed to add the necessary number of new rows using the [Transaction Update API](https://www.ag-grid.com/vue-data-grid/data-update-transactions/#transaction-update-api).

The example below uses a custom `processDataFromClipboard` function to add new rows to the grid, to fit all the copied rows:

- Select the top 3 rows in the grid using `⇧ Shift` + click
- Press `^ Ctrl`+`C` to copy the selected rows
- Select the `Ryan Lochte` cell on the last row and press `^ Ctrl`+`V` to paste the copied rows
- Notice that the `Ryan Lochte` row has been overwritten and 2 extra rows are created at the bottom of the grid to accommodate the additional 2 rows pasted

#### Paste New Rows

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ColumnApiModule,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  ProcessDataFromClipboard,
  ProcessDataFromClipboardParams,
  RowApiModule,
  RowSelectionModule,
  RowSelectionOptions,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ColumnApiModule,
  RowApiModule,
  ClientSideRowModelApiModule,
  NumberEditorModule,
  TextEditorModule,
  RowSelectionModule,
  ClientSideRowModelModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :rowSelection="rowSelection"
      :processDataFromClipboard="processDataFromClipboard"
      :rowData="rowData"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi | null>(null);
    const columnDefs = ref<ColDef[]>([
      { headerName: "Athlete", field: "athlete", width: 150 },
      { headerName: "Age", field: "age", width: 90 },
      { headerName: "Country", field: "country", width: 120 },
      { headerName: "Year", field: "year", width: 90 },
      { headerName: "Date", field: "date", width: 110 },
      { headerName: "Sport", field: "sport", width: 110 },
    ]);
    const defaultColDef = ref<ColDef>({
      editable: true,
    });
    const rowSelection = ref<RowSelectionOptions | "single" | "multiple">({
      mode: "multiRow",
      checkboxes: false,
      headerCheckbox: false,
      enableClickSelection: true,
      copySelectedRows: true,
    });
    const rowData = ref<any[]>(null);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data.slice(0, 8));

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };
    const processDataFromClipboard: (
      params: ProcessDataFromClipboardParams,
    ) => string[][] | null = (params: ProcessDataFromClipboardParams) => {
      const data = [...params.data];
      const emptyLastRow =
        data[data.length - 1][0] === "" && data[data.length - 1].length === 1;
      if (emptyLastRow) {
        data.splice(data.length - 1, 1);
      }
      const lastIndex = params.api!.getDisplayedRowCount() - 1;
      const focusedCell = params.api!.getFocusedCell();
      const focusedIndex = focusedCell!.rowIndex;
      if (focusedIndex + data.length - 1 > lastIndex) {
        const resultLastIndex = focusedIndex + (data.length - 1);
        const numRowsToAdd = resultLastIndex - lastIndex;
        const rowsToAdd: any[] = [];
        for (let i = 0; i < numRowsToAdd; i++) {
          const index = data.length - 1;
          const row = data.slice(index, index + 1)[0];
          // Create row object
          const rowObject: any = {};
          let currentColumn: any = focusedCell!.column;
          row.forEach((item) => {
            if (!currentColumn) {
              return;
            }
            rowObject[currentColumn.colDef.field] = item;
            currentColumn = params.api!.getDisplayedColAfter(currentColumn);
          });
          rowsToAdd.push(rowObject);
        }
        params.api!.applyTransaction({ add: rowsToAdd });
      }
      return data;
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      rowSelection,
      processDataFromClipboard,
      rowData,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Paste New Rows](https://www.ag-grid.com/examples/clipboard/pasting-extra-rows/vue3/)

### Read Only Edit

When the grid is in [Read Only Edit](https://www.ag-grid.com/vue-data-grid/value-setters/#read-only-edit) mode the `Clipboard` will not update the data inside the grid. Instead the grid fires `cellEditRequest` events allowing the application to process the update request.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `cellEditRequest` | `CellEditRequestEvent` |  |  |  |

The example below will show how to update cell value combining the `Clipboard` with `readOnlyEdit=true`.

#### Clipboard - ReadOnlyEdit

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  CellEditRequestEvent,
  CellSelectionOptions,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GetRowIdFunc,
  GetRowIdParams,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import { CellSelectionModule, ClipboardModule } from "ag-grid-enterprise";
import { IOlympicDataWithId } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelModule,
  ClipboardModule,
  CellSelectionModule,
]);

let rowImmutableStore: any[];

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :getRowId="getRowId"
      :cellSelection="true"
      :readOnlyEdit="true"
      :rowData="rowData"
      @cell-edit-request="onCellEditRequest"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicDataWithId> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "athlete", minWidth: 160 },
      { field: "age" },
      { field: "country", minWidth: 140 },
      { field: "year" },
      { field: "date", minWidth: 140 },
      { field: "sport", minWidth: 160 },
      { field: "gold" },
      { field: "silver" },
      { field: "bronze" },
      { field: "total" },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
      minWidth: 100,
      editable: true,
    });
    const getRowId = ref<GetRowIdFunc>((params: GetRowIdParams) =>
      String(params.data.id),
    );
    const rowData = ref<IOlympicDataWithId[]>(null);

    function onCellEditRequest(event: CellEditRequestEvent) {
      const data = event.data;
      const field = event.colDef.field;
      const newValue = event.newValue;
      const oldItem = rowImmutableStore.find((row) => row.id === data.id);
      if (!oldItem || !field) {
        return;
      }
      const newItem = { ...oldItem };
      newItem[field] = newValue;
      console.log("onCellEditRequest, updating " + field + " to " + newValue);
      rowImmutableStore = rowImmutableStore.map((oldItem) =>
        oldItem.id == newItem.id ? newItem : oldItem,
      );
      gridApi.value!.setGridOption("rowData", rowImmutableStore);
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => {
        data.forEach((item, index) => (item.id = index));
        rowImmutableStore = data;
        params.api!.setGridOption("rowData", rowImmutableStore);
      };

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      getRowId,
      rowData,
      onGridReady,
      onCellEditRequest,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Clipboard - ReadOnlyEdit](https://www.ag-grid.com/examples/clipboard/read-only-edit/vue3/)

## Changing the Delimiter for Copy & Paste

By default, the grid will use `\t` (tab) as the field delimiter. This is to keep the copy / paste compatible with Excel. If you want another delimiter then you can set the property `gridOptions.clipboardDelimiter` to a value of your choosing.

## Using the Browser's Text Selection

The grid's selection and copy features replace the built-in browser behaviour for selecting and copying text. If you want to use the normal browser behaviour instead, you should set `enableCellTextSelection=true` in the gridOptions. Note the following:

- When `enableCellTextSelection=true`, pressing `^ Ctrl`+`C` doesn’t copy the focused cell value, but only the selected text inside the grid cell. When using AG Grid Enterprise, the user can copy the entire cell value by right-clicking the grid cell to show the [context menu](https://www.ag-grid.com/vue-data-grid/context-menu/) and clicking the any of the Copy menu items.
- When `enableCellTextSelection=true`, the option `ensureDomOrder=true` needs to be set for correct accessibility support. See [Ensure DOM Element order](https://www.ag-grid.com/vue-data-grid/accessibility/#ensure-dom-element-order).

> **Note**
>
> This is not an enterprise config and can be used at any time to enable cell text selection.

See this behaviour shown in the example below:

- Focus a grid cell and press `^ Ctrl`+`C`. The cell value will not be copied because no text is selected.
- Click a cell and drag across its value to select the text. Press `^ Ctrl`+`C` and the value will be copied.
- This sample is using AG Grid Community version, so the context menu is not available to copy the focused cell value. In AG Grid Enterprise the context menu will be available to copy the entire focused cell value without having to select it as text.

#### Using Browser text selection

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :ensureDomOrder="true"
      :enableCellTextSelection="true"
      :rowData="rowData"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "athlete", minWidth: 200 },
      { field: "age" },
      { field: "country", minWidth: 150 },
      { field: "year" },
      { field: "date", minWidth: 150 },
      { field: "sport", minWidth: 150 },
      { field: "gold" },
      { field: "silver", suppressPaste: true },
      { field: "bronze" },
      { field: "total" },
    ]);
    const defaultColDef = ref<ColDef>({
      editable: true,
      flex: 1,
      minWidth: 100,
    });
    const rowData = ref<IOlympicData[]>(null);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data);

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      rowData,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Using Browser text selection](https://www.ag-grid.com/examples/clipboard/cellTextSelection/vue3/)

## Clipboard Events

The following events are relevant to clipboard operations:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `cutStart` | `CutStartEvent` |  |  |  |
| `cutEnd` | `CutEndEvent` |  |  |  |
| `pasteStart` | `PasteStartEvent` |  |  |  |
| `pasteEnd` | `PasteEndEvent` |  |  |  |

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `cellValueChanged` | `CellValueChangedEvent` |  |  |  |

For a cut or paste operation the events will be fired as:

1. One `cutStart`/`pasteStart` event.
2. Many `cellValueChanged` events.
3. One `cutEnd`/`pasteEnd` event.

If the application is doing work each time it receives a `cellValueChanged`, you can use the `cutStart`/`pasteStart` and `cutEnd`/`pasteEnd` events to suspend the applications work and then do the work for all cells impacted by the cut/paste operation after the cut/paste operation.

There are no events triggered by copy to clipboard as this does not change the grid's data.

#### Clipboard Events

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  CellSelectionOptions,
  CellValueChangedEvent,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  CutEndEvent,
  CutStartEvent,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  PasteEndEvent,
  PasteStartEvent,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :cellSelection="true"
      :rowData="rowData"
      @cell-value-changed="onCellValueChanged"
      @cut-start="onCutStart"
      @cut-end="onCutEnd"
      @paste-start="onPasteStart"
      @paste-end="onPasteEnd"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "athlete", minWidth: 200 },
      { field: "age" },
      { field: "country", minWidth: 150 },
      { field: "year" },
      { field: "date", minWidth: 150 },
      { field: "sport", minWidth: 150 },
      { field: "gold" },
      { field: "silver" },
      { field: "bronze" },
      { field: "total" },
    ]);
    const defaultColDef = ref<ColDef>({
      editable: true,
      flex: 1,
      minWidth: 100,
    });
    const rowData = ref<IOlympicData[]>(null);

    function onCellValueChanged(params: CellValueChangedEvent) {
      console.log("Callback onCellValueChanged:", params);
    }
    function onCutStart(params: CutStartEvent) {
      console.log("Callback onCutStart:", params);
    }
    function onCutEnd(params: CutEndEvent) {
      console.log("Callback onCutEnd:", params);
    }
    function onPasteStart(params: PasteStartEvent) {
      console.log("Callback onPasteStart:", params);
    }
    function onPasteEnd(params: PasteEndEvent) {
      console.log("Callback onPasteEnd:", params);
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data);

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      rowData,
      onGridReady,
      onCellValueChanged,
      onCutStart,
      onCutEnd,
      onPasteStart,
      onPasteEnd,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Clipboard Events](https://www.ag-grid.com/examples/clipboard/clipboard-events/vue3/)


---
title: "Clipboard"
enterprise: true
framework: angular
version: "36.1.0"
---

# Clipboard

You can copy and paste items to and from the grid using the system clipboard.

## How to copy

Copying from the grid is **enabled by default** for enterprise users. To copy your selection to the system clipboard, you can use the keybind `^ Ctrl`+`C`, or right click on a cell and select 'Copy' from the context menu. Unless [Cell Selection](https://www.ag-grid.com/angular-data-grid/cell-selection/) or [Row Selection](https://www.ag-grid.com/angular-data-grid/row-selection/) is enabled, you will only be copying from the currently focused cell.

When copying multiple cells, the contents will be copied in an Excel compatible format, with fields separated by a `\t` (tab) character.

## Copying Cell Ranges

When [Cell Ranges](https://www.ag-grid.com/angular-data-grid/cell-selection/) are enabled by setting `gridOptions.cellSelection=true`, copying will copy the Cell Range's content to your clipboard. Select a range by clicking on a cell and dragging with the mouse, then copy with the `^ Ctrl`+`C` keybind.

Multiple cell ranges can be selected at once using `^ Ctrl` and dragging with the mouse. When copying, all ranges will be copied to the clipboard. Note that the relative positions of multiple ranges is not preserved when copying, they are stacked vertically in the clipboard.

In the below example try:

- Select a cell range with click & drag
- Copy with `^ Ctrl`+`C`
- Paste into an external program / text editor.

#### Copying Cell Ranges

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
  CellSelectionOptions,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [cellSelection]="true"
    [rowData]="rowData"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "athlete", minWidth: 200 },
    { field: "age" },
    { field: "country", minWidth: 150 },
    { field: "year" },
    { field: "date", minWidth: 150 },
    { field: "sport", minWidth: 150 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ];
  defaultColDef: ColDef = {
    editable: true,
    flex: 1,
    minWidth: 100,
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Copying Cell Ranges](https://www.ag-grid.com/examples/clipboard/copy-range/angular)

## Copying Rows

When [Row Selection](https://www.ag-grid.com/angular-data-grid/row-selection/) is enabled by setting `gridOptions.rowSelection.mode` to either `"singleRow"` or `"multiRow"`, the default behaviour is to copy only the focused cell to the clipboard. In order to copy the whole row, enable the `gridOptions.rowSelection.copySelectedRows` flag.

```ts
<ag-grid-angular
    [rowSelection]="rowSelection"
    /* other grid options ... */ />

this.rowSelection = {
    mode: 'multiRow',
    copySelectedRows: true,
};
```

The below example demonstrates copying rows. Initially, pressing `^ Ctrl`+C will select the focused cell, regardless of which rows have been selected. You can change this behaviour by toggling the "Copy Selected Rows" checkbox to enable the `copySelectedRows` flag:

- Toggle the "Copy Selected Rows" checkbox on
- Select one or more rows in the example below and press `^ Ctrl`+C
- Paste copied content in a text editor
- When the "Copy Selected Rows" checkbox is toggled on, the pasted content includes all selected rows. When the "Copy Selected Rows" checkbox is toggled off, the pasted content includes only the focussed cell.

#### Copying Rows

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./style.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  RowSelectionModule,
  RowSelectionOptions,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
  RowSelectionModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<div class="example-wrapper">
    <div class="example-header">
      <label for="toggle-copy-rows">Copy Selected Rows: </label>
      <input
        type="checkbox"
        id="toggle-copy-rows"
        (change)="toggleCopyRows()"
      />
    </div>
    <ag-grid-angular
      style="width: 100%; height: 100%;"
      [columnDefs]="columnDefs"
      [defaultColDef]="defaultColDef"
      [rowSelection]="rowSelection"
      [rowData]="rowData"
      (gridReady)="onGridReady($event)"
    />
  </div> `,
})
export class AppComponent {
  private gridApi!: GridApi<IOlympicData>;

  columnDefs: ColDef[] = [
    { field: "athlete", minWidth: 200 },
    { field: "age" },
    { field: "country", minWidth: 150 },
    { field: "year" },
    { field: "date", minWidth: 150 },
    { field: "sport", minWidth: 150 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ];
  defaultColDef: ColDef = {
    editable: true,
    flex: 1,
    minWidth: 100,
  };
  rowSelection: RowSelectionOptions | "single" | "multiple" = {
    mode: "multiRow",
    copySelectedRows: false,
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  toggleCopyRows() {
    this.gridApi.setGridOption("rowSelection", {
      mode: "multiRow",
      copySelectedRows:
        document.querySelector<HTMLInputElement>("#toggle-copy-rows")
          ?.checked ?? false,
    });
  }

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.gridApi = params.api;

    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Copying Rows](https://www.ag-grid.com/examples/clipboard/copy-row/angular)

## Copying Headers

The column headers can be copied to the clipboard in addition to the cell contents by enabling the option `copyHeadersToClipboard`.

```ts
<ag-grid-angular
    [copyHeadersToClipboard]="copyHeadersToClipboard"
    /* other grid options ... */ />

this.copyHeadersToClipboard = true;
```

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `copyHeadersToClipboard` | `boolean` |  | `false` | Set to `true` to also include headers when copying to clipboard using ^ Ctrl+C clipboard. Default: `false` Module: [`ClipboardModule`](https://www.ag-grid.com/angular-data-grid/modules/). |

In the below example try:

- Select a cell range with click & drag
- Copy with `^ Ctrl`+`C`
- Paste into an external program / text editor, note that the column headers were also copied.

#### Copying Cell Ranges and Headers

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
  CellSelectionOptions,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [cellSelection]="true"
    [copyHeadersToClipboard]="true"
    [rowData]="rowData"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "athlete", minWidth: 200 },
    { field: "age" },
    { field: "country", minWidth: 150 },
    { field: "year" },
    { field: "date", minWidth: 150 },
    { field: "sport", minWidth: 150 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ];
  defaultColDef: ColDef = {
    editable: true,
    flex: 1,
    minWidth: 100,
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Copying Cell Ranges and Headers](https://www.ag-grid.com/examples/clipboard/copy-range-with-headers/angular)

## Custom Clipboard Interaction

If you want to do the copy to clipboard yourself (i.e. not use the grid's clipboard interaction) then implement the callback `sendToClipboard(params)`. Use this if you are in a non-standard web container that has a bespoke API for interacting with the clipboard. The callback gets the data to go into the clipboard, it's your job to call the bespoke API.

The example below shows using `sendToClipboard(params)`, but rather than using the clipboard, demonstrates the callback by just printing the data to the console.

#### Controlling Clipboard Copy

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
  CellSelectionOptions,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  RowSelectionModule,
  RowSelectionOptions,
  SendToClipboard,
  SendToClipboardParams,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  RowSelectionModule,
  ClientSideRowModelModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<div style="display: flex; height: 100%; flex-direction: column">
    <div style="padding-bottom: 5px">
      <button (click)="onBtCopyRows()">Copy Selected Rows to Clipboard</button>
      <button (click)="onBtCopyRange()">
        Copy Selected Range to Clipboard
      </button>
    </div>

    <ag-grid-angular
      style="width: 100%; height: 100%;"
      [columnDefs]="columnDefs"
      [defaultColDef]="defaultColDef"
      [cellSelection]="true"
      [rowSelection]="rowSelection"
      [sendToClipboard]="sendToClipboard"
      [rowData]="rowData"
      (gridReady)="onGridReady($event)"
    />
  </div> `,
})
export class AppComponent {
  private gridApi!: GridApi<IOlympicData>;

  columnDefs: ColDef[] = [
    { field: "athlete", minWidth: 200 },
    { field: "age" },
    { field: "country", minWidth: 150 },
    { field: "year" },
    { field: "date", minWidth: 150 },
    { field: "sport", minWidth: 150 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ];
  defaultColDef: ColDef = {
    editable: true,
    flex: 1,
    minWidth: 100,
  };
  rowSelection: RowSelectionOptions | "single" | "multiple" = {
    mode: "multiRow",
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onBtCopyRows() {
    this.gridApi.copySelectedRowsToClipboard();
  }

  onBtCopyRange() {
    this.gridApi.copySelectedRangeToClipboard();
  }

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.gridApi = params.api;

    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }

  sendToClipboard = (params: SendToClipboardParams) => {
    console.log("send to clipboard called with data:");
    console.log(params.data);
  };
}
```

[Live example: Controlling Clipboard Copy](https://www.ag-grid.com/examples/clipboard/custom/angular)

## Copying via the API

You can use the Grid API methods: `copySelectedRowsToClipboard(...)` and `copySelectedRangeToClipboard(...)` to copy rows or ranges respectively, these API calls take optional parameters to enable copying column and group headers.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `copySelectedRangeToClipboard` | `Function` |  |  | Copies the selected ranges to the clipboard. Module: [`ClipboardModule`](https://www.ag-grid.com/angular-data-grid/modules/). |
| `copySelectedRowsToClipboard` | `Function` |  |  | Copies the selected rows to the clipboard. Module: [`ClipboardModule`](https://www.ag-grid.com/angular-data-grid/modules/). |

## How to Cut

Cut from the grid is **enabled by default** for enterprise users. To cut your selection to the system clipboard, you can use the keybind `^ Ctrl`+`X`, or right click on a cell and select 'Cut' from the context menu. Unless [Range Selection](https://www.ag-grid.com/angular-data-grid/cell-selection/) or [Row Selection](https://www.ag-grid.com/angular-data-grid/row-selection/) is enabled, you will only be copying from the currently focused cell.

The cut operations will work exactly the same as the copy operations, with the addition that data will be removed from the grid afterwards, so the cut operations will use the same properties described above to customise the `copy` process.

## Disabling Cut

Since `Cut` is a destructive process, the `suppressCutToClipboard` property was added to the Grid Options.

```ts
<ag-grid-angular
    [suppressCutToClipboard]="suppressCutToClipboard"
    /* other grid options ... */ />

this.suppressCutToClipboard = true;
```

This is demonstrated in the example below. Note the following:

- Selecting a cell and pressing `^ Ctrl`+`X` will not `copy` or `cut` the data.
- The context menu will not show an option to `Cut`.

#### Clipboard Suppress Cut

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
  CellSelectionOptions,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [cellSelection]="true"
    [suppressCutToClipboard]="true"
    [rowData]="rowData"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "athlete", minWidth: 200 },
    { field: "age" },
    { field: "country", minWidth: 150 },
    { field: "year" },
    { field: "date", minWidth: 150 },
    { field: "sport", minWidth: 150 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ];
  defaultColDef: ColDef = {
    editable: true,
    flex: 1,
    minWidth: 100,
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Clipboard Suppress Cut](https://www.ag-grid.com/examples/clipboard/suppress-cut/angular)

## How to Paste

Paste is enabled by default in the enterprise version and is possible as long as the cells you're pasting into are [editable](https://www.ag-grid.com/angular-data-grid/cell-editing/) (non-editable cells cannot be modified, even with a paste operation). You can paste using the keybind `^ Ctrl`+`V` while focus is on the grid.

The behaviour of paste changes depending on whether you have a single cell or a range selected:

- When a **single cell is selected**. The paste will proceed starting at the selected cell if multiple cells are to be pasted.
- When a **range of cells selected**. If the selected range being pasted is larger than copied range, it will repeat if it fits evenly, otherwise it will just copy the cells into the start of the range.

## Disabling Paste

You can turn paste operations off for the entire grid, by setting the grid property `suppressClipboardPaste=true`.

Or you can disable pasting for a specific column or cell by setting the property `suppressPaste` on the column definition. This can be a boolean or a function (use a function to specify for a particular cell, or boolean for the whole column).

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `suppressPaste` | `boolean \| SuppressPasteCallback` |  |  | Pasting is on by default as long as cells are editable (non-editable cells cannot be modified, even with a paste operation). Set to `true` turn paste operations off. |

## Processing Pasted Data

The clipboard data will be processed by default [Using the Value Formatter for Export](https://www.ag-grid.com/angular-data-grid/value-formatters/#formatting-for-export) to format the cells when copied, and [Using the Value Parser for Import](https://www.ag-grid.com/angular-data-grid/value-parsers/#use-value-parser-for-import) to format the cells when pasted.

It is possible to override this behaviour specifically for the clipboard. This can be done either on individual cells or the whole paste operation.

### Processing Individual Cells

The interfaces and parameters for processing individual cells are as follows:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `processCellForClipboard` | `ProcessCellForClipboard` |  |  | Allows you to process cells for the clipboard. Handy if for example you have `Date` objects that need to have a particular format if importing into Excel. Module: [`ClipboardModule`](https://www.ag-grid.com/angular-data-grid/modules/). |
| `processHeaderForClipboard` | `ProcessHeaderForClipboard` |  |  | Allows you to process header values for the clipboard. Module: [`ClipboardModule`](https://www.ag-grid.com/angular-data-grid/modules/). |
| `processGroupHeaderForClipboard` | `ProcessGroupHeaderForClipboard` |  |  | Allows you to process group header values for the clipboard. Module: [`ClipboardModule`](https://www.ag-grid.com/angular-data-grid/modules/). |
| `processCellFromClipboard` | `ProcessCellFromClipboard` |  |  | Allows you to process cells from the clipboard. Handy if for example you have number fields and want to block non-numbers from getting into the grid. Module: [`ClipboardModule`](https://www.ag-grid.com/angular-data-grid/modules/). |

These three callbacks above are demonstrated in the example below. Note the following:

- When cells are copied to the clipboard, values are prefixed with 'C-'. Cells can be copied by dragging a range with the mouse and hitting `^ Ctrl`+`C`.
- When cells are pasted from the clipboard, values are prefixed with 'Z-'. Cells can be pasted by hitting `^ Ctrl`+`V`.
- When headers are copied to the clipboard, values are prefixed with 'H-'. Headers can be copied by using the context menu.
- When group headers are copied to the clipboard, values are prefixed with 'GH-'. Headers can be copied by using the context menu.

#### Example Process

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
  CellSelectionOptions,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  ProcessCellForClipboard,
  ProcessCellForExportParams,
  ProcessCellFromClipboard,
  ProcessGroupHeaderForClipboard,
  ProcessGroupHeaderForExportParams,
  ProcessHeaderForClipboard,
  ProcessHeaderForExportParams,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [cellSelection]="true"
    [processCellForClipboard]="processCellForClipboard"
    [processHeaderForClipboard]="processHeaderForClipboard"
    [processGroupHeaderForClipboard]="processGroupHeaderForClipboard"
    [processCellFromClipboard]="processCellFromClipboard"
    [rowData]="rowData"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: (ColDef | ColGroupDef)[] = [
    {
      headerName: "Participants",
      children: [
        { field: "athlete", headerName: "Athlete Name", minWidth: 200 },
        { field: "age" },
        { field: "country", minWidth: 150 },
      ],
    },
    {
      headerName: "Olympic Games",
      children: [
        { field: "year" },
        { field: "date", minWidth: 150 },
        { field: "sport", minWidth: 150 },
        { field: "gold" },
        { field: "silver", suppressPaste: true },
        { field: "bronze" },
        { field: "total" },
      ],
    },
  ];
  defaultColDef: ColDef = {
    editable: true,
    flex: 1,
    minWidth: 100,
    cellDataType: false,
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }

  processCellForClipboard = (params: ProcessCellForExportParams) => {
    return "C-" + params.value;
  };

  processHeaderForClipboard = (params: ProcessHeaderForExportParams) => {
    const colDef = params.column.getColDef();
    let headerName = colDef.headerName || colDef.field || "";
    if (colDef.headerName !== "") {
      headerName = headerName.charAt(0).toUpperCase() + headerName.slice(1);
    }
    return "H-" + headerName;
  };

  processGroupHeaderForClipboard = (
    params: ProcessGroupHeaderForExportParams,
  ) => {
    const colGroupDef = params.columnGroup.getColGroupDef() || ({} as any);
    const headerName = colGroupDef.headerName || "";
    if (headerName === "") {
      return "";
    }
    return "GH-" + headerName;
  };

  processCellFromClipboard = (params: ProcessCellForExportParams) => {
    return "Z-" + params.value;
  };
}
```

[Live example: Example Process](https://www.ag-grid.com/examples/clipboard/process/angular)

### Processing Data from Clipboard

To have complete control of processing clipboard data when pasting, you can use the callback below:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `processDataFromClipboard` | `ProcessDataFromClipboard` |  |  | Allows complete control of the paste operation, including cancelling the operation (so nothing happens) or replacing the data with other data. Module: [`ClipboardModule`](https://www.ag-grid.com/angular-data-grid/modules/). |

The following example shows custom code to process the data from the clipboard:

- The cells are coloured based on the colour that the cell content starts with
- Copy a cell range in the grid which includes a cell value that starts with `Red`. Pasting into the grid will paste a custom 4x4 cell grid.
- Copy a cell range in the grid which includes a cell value that starts with `Yellow` and **doesn’t** include any `Red` cell values. Pasting this copied cell range will cancel the paste action and not paste anything
- Any other copied cell data will be pasted as-is

#### Example Process Data

```ts
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./style.css";
import {
  CellSelectionOptions,
  CellStyleModule,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  ProcessDataFromClipboard,
  ProcessDataFromClipboardParams,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
import { getData } from "./data";
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  TextEditorModule,
  CellStyleModule,
  ClientSideRowModelModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
]);

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [rowData]="rowData"
    [cellSelection]="true"
    [defaultColDef]="defaultColDef"
    [processDataFromClipboard]="processDataFromClipboard"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "a" },
    { field: "b" },
    { field: "c" },
    { field: "d" },
    { field: "e" },
  ];
  rowData: any[] | null = getData();
  defaultColDef: ColDef = {
    editable: true,
    minWidth: 120,
    flex: 1,
    cellClassRules: {
      "cell-green": 'value && value.startsWith("Green")',
      "cell-blue": 'value && value.startsWith("Blue")',
      "cell-red": 'value && value.startsWith("Red")',
      "cell-yellow": 'value && value.startsWith("Yellow")',
    },
  };

  processDataFromClipboard = (
    params: ProcessDataFromClipboardParams,
  ): string[][] | null => {
    let containsRed;
    let containsYellow;
    const data = params.data;
    for (let i = 0; i < data.length; i++) {
      const row = data[i];
      for (let j = 0; j < row.length; j++) {
        const value = row[j];
        if (value) {
          if (value.startsWith("Red")) {
            containsRed = true;
          } else if (value.startsWith("Yellow")) {
            containsYellow = true;
          }
        }
      }
    }
    if (containsRed) {
      // replace the paste request with another
      return [
        ["Custom 1", "Custom 2"],
        ["Custom 3", "Custom 4"],
      ];
    }
    if (containsYellow) {
      // cancels the paste
      return null;
    }
    return data;
  };
}
```

[Live example: Example Process Data](https://www.ag-grid.com/examples/clipboard/process-all/angular)

### Pasting New Rows at the Bottom of the Grid

By default, when pasting multiple rows near the last record shown in the grid, any rows exceeding the total number of rows shown in the grid will not be pasted.

In order to insert all the copied rows in the grid, a custom `processDataFromClipboard` function is needed to add the necessary number of new rows using the [Transaction Update API](https://www.ag-grid.com/angular-data-grid/data-update-transactions/#transaction-update-api).

The example below uses a custom `processDataFromClipboard` function to add new rows to the grid, to fit all the copied rows:

- Select the top 3 rows in the grid using `⇧ Shift` + click
- Press `^ Ctrl`+`C` to copy the selected rows
- Select the `Ryan Lochte` cell on the last row and press `^ Ctrl`+`V` to paste the copied rows
- Notice that the `Ryan Lochte` row has been overwritten and 2 extra rows are created at the bottom of the grid to accommodate the additional 2 rows pasted

#### Paste New Rows

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ColumnApiModule,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  ProcessDataFromClipboard,
  ProcessDataFromClipboardParams,
  RowApiModule,
  RowSelectionModule,
  RowSelectionOptions,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ColumnApiModule,
  RowApiModule,
  ClientSideRowModelApiModule,
  NumberEditorModule,
  TextEditorModule,
  RowSelectionModule,
  ClientSideRowModelModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
]);

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [rowSelection]="rowSelection"
    [processDataFromClipboard]="processDataFromClipboard"
    [rowData]="rowData"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { headerName: "Athlete", field: "athlete", width: 150 },
    { headerName: "Age", field: "age", width: 90 },
    { headerName: "Country", field: "country", width: 120 },
    { headerName: "Year", field: "year", width: 90 },
    { headerName: "Date", field: "date", width: 110 },
    { headerName: "Sport", field: "sport", width: 110 },
  ];
  defaultColDef: ColDef = {
    editable: true,
  };
  rowSelection: RowSelectionOptions | "single" | "multiple" = {
    mode: "multiRow",
    checkboxes: false,
    headerCheckbox: false,
    enableClickSelection: true,
    copySelectedRows: true,
  };
  rowData!: any[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent) {
    this.http
      .get<any[]>("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data.slice(0, 8)));
  }

  processDataFromClipboard = (
    params: ProcessDataFromClipboardParams,
  ): string[][] | null => {
    const data = [...params.data];
    const emptyLastRow =
      data[data.length - 1][0] === "" && data[data.length - 1].length === 1;
    if (emptyLastRow) {
      data.splice(data.length - 1, 1);
    }
    const lastIndex = params.api!.getDisplayedRowCount() - 1;
    const focusedCell = params.api!.getFocusedCell();
    const focusedIndex = focusedCell!.rowIndex;
    if (focusedIndex + data.length - 1 > lastIndex) {
      const resultLastIndex = focusedIndex + (data.length - 1);
      const numRowsToAdd = resultLastIndex - lastIndex;
      const rowsToAdd: any[] = [];
      for (let i = 0; i < numRowsToAdd; i++) {
        const index = data.length - 1;
        const row = data.slice(index, index + 1)[0];
        // Create row object
        const rowObject: any = {};
        let currentColumn: any = focusedCell!.column;
        row.forEach((item) => {
          if (!currentColumn) {
            return;
          }
          rowObject[currentColumn.colDef.field] = item;
          currentColumn = params.api!.getDisplayedColAfter(currentColumn);
        });
        rowsToAdd.push(rowObject);
      }
      params.api!.applyTransaction({ add: rowsToAdd });
    }
    return data;
  };
}
```

[Live example: Paste New Rows](https://www.ag-grid.com/examples/clipboard/pasting-extra-rows/angular)

### Read Only Edit

When the grid is in [Read Only Edit](https://www.ag-grid.com/angular-data-grid/value-setters/#read-only-edit) mode the `Clipboard` will not update the data inside the grid. Instead the grid fires `cellEditRequest` events allowing the application to process the update request.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `cellEditRequest` | `CellEditRequestEvent` |  |  | Value has changed after editing. Only fires when `readOnlyEdit=true`. |

The example below will show how to update cell value combining the `Clipboard` with `readOnlyEdit=true`.

#### Clipboard - ReadOnlyEdit

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
  CellEditRequestEvent,
  CellSelectionOptions,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GetRowIdFunc,
  GetRowIdParams,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import { CellSelectionModule, ClipboardModule } from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelModule,
  ClipboardModule,
  CellSelectionModule,
]);
import { IOlympicDataWithId } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [getRowId]="getRowId"
    [cellSelection]="true"
    [readOnlyEdit]="true"
    [rowData]="rowData"
    (cellEditRequest)="onCellEditRequest($event)"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  private gridApi!: GridApi<IOlympicDataWithId>;

  columnDefs: ColDef[] = [
    { field: "athlete", minWidth: 160 },
    { field: "age" },
    { field: "country", minWidth: 140 },
    { field: "year" },
    { field: "date", minWidth: 140 },
    { field: "sport", minWidth: 160 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    minWidth: 100,
    editable: true,
  };
  getRowId: GetRowIdFunc = (params: GetRowIdParams) => String(params.data.id);
  rowData!: IOlympicDataWithId[];

  constructor(private http: HttpClient) {}

  onCellEditRequest(event: CellEditRequestEvent) {
    const data = event.data;
    const field = event.colDef.field;
    const newValue = event.newValue;
    const oldItem = rowImmutableStore.find((row) => row.id === data.id);
    if (!oldItem || !field) {
      return;
    }
    const newItem = { ...oldItem };
    newItem[field] = newValue;
    console.log("onCellEditRequest, updating " + field + " to " + newValue);
    rowImmutableStore = rowImmutableStore.map((oldItem) =>
      oldItem.id == newItem.id ? newItem : oldItem,
    );
    this.gridApi.setGridOption("rowData", rowImmutableStore);
  }

  onGridReady(params: GridReadyEvent<IOlympicDataWithId>) {
    this.gridApi = params.api;

    this.http
      .get<
        IOlympicDataWithId[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => {
        data.forEach((item, index) => (item.id = index));
        rowImmutableStore = data;
        params.api!.setGridOption("rowData", rowImmutableStore);
      });
  }
}

let rowImmutableStore: any[];
```

[Live example: Clipboard - ReadOnlyEdit](https://www.ag-grid.com/examples/clipboard/read-only-edit/angular)

## Changing the Delimiter for Copy & Paste

By default, the grid will use `\t` (tab) as the field delimiter. This is to keep the copy / paste compatible with Excel. If you want another delimiter then you can set the property `gridOptions.clipboardDelimiter` to a value of your choosing.

## Using the Browser's Text Selection

The grid's selection and copy features replace the built-in browser behaviour for selecting and copying text. If you want to use the normal browser behaviour instead, you should set `enableCellTextSelection=true` in the gridOptions. Note the following:

- When `enableCellTextSelection=true`, pressing `^ Ctrl`+`C` doesn’t copy the focused cell value, but only the selected text inside the grid cell. When using AG Grid Enterprise, the user can copy the entire cell value by right-clicking the grid cell to show the [context menu](https://www.ag-grid.com/angular-data-grid/context-menu/) and clicking the any of the Copy menu items.
- When `enableCellTextSelection=true`, the option `ensureDomOrder=true` needs to be set for correct accessibility support. See [Ensure DOM Element order](https://www.ag-grid.com/angular-data-grid/accessibility/#ensure-dom-element-order).

> **Note**
>
> This is not an enterprise config and can be used at any time to enable cell text selection.

See this behaviour shown in the example below:

- Focus a grid cell and press `^ Ctrl`+`C`. The cell value will not be copied because no text is selected.
- Click a cell and drag across its value to select the text. Press `^ Ctrl`+`C` and the value will be copied.
- This sample is using AG Grid Community version, so the context menu is not available to copy the focused cell value. In AG Grid Enterprise the context menu will be available to copy the entire focused cell value without having to select it as text.

#### Using Browser text selection

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [ensureDomOrder]="true"
    [enableCellTextSelection]="true"
    [rowData]="rowData"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "athlete", minWidth: 200 },
    { field: "age" },
    { field: "country", minWidth: 150 },
    { field: "year" },
    { field: "date", minWidth: 150 },
    { field: "sport", minWidth: 150 },
    { field: "gold" },
    { field: "silver", suppressPaste: true },
    { field: "bronze" },
    { field: "total" },
  ];
  defaultColDef: ColDef = {
    editable: true,
    flex: 1,
    minWidth: 100,
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Using Browser text selection](https://www.ag-grid.com/examples/clipboard/cellTextSelection/angular)

## Clipboard Events

The following events are relevant to clipboard operations:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `cutStart` | `CutStartEvent` |  |  | Cut operation has started. |
| `cutEnd` | `CutEndEvent` |  |  | Cut operation has ended. |
| `pasteStart` | `PasteStartEvent` |  |  | Paste operation has started. |
| `pasteEnd` | `PasteEndEvent` |  |  | Paste operation has ended. |

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `cellValueChanged` | `CellValueChangedEvent` |  |  | Cell value has changed. This occurs after the following scenarios: - Editing. Will not fire if any of the following are true: new value is the same as old value; `readOnlyEdit = true`; editing was cancelled (e.g. Escape key was pressed); or new value is of the wrong cell data type for the column. - Cut. - Paste. - Cell clear (pressing Delete key). - Fill handle. - Copy range down. - Undo and redo. See [Editing Events](https://www.ag-grid.com/angular-data-grid/cell-editing/#editing-events) for more information. |

For a cut or paste operation the events will be fired as:

1. One `cutStart`/`pasteStart` event.
2. Many `cellValueChanged` events.
3. One `cutEnd`/`pasteEnd` event.

If the application is doing work each time it receives a `cellValueChanged`, you can use the `cutStart`/`pasteStart` and `cutEnd`/`pasteEnd` events to suspend the applications work and then do the work for all cells impacted by the cut/paste operation after the cut/paste operation.

There are no events triggered by copy to clipboard as this does not change the grid's data.

#### Clipboard Events

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
  CellSelectionOptions,
  CellValueChangedEvent,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  CutEndEvent,
  CutStartEvent,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberEditorModule,
  PasteEndEvent,
  PasteStartEvent,
  TextEditorModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  CellSelectionModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  NumberEditorModule,
  TextEditorModule,
  ClientSideRowModelModule,
  ClipboardModule,
  ColumnMenuModule,
  ContextMenuModule,
  CellSelectionModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [cellSelection]="true"
    [rowData]="rowData"
    (cellValueChanged)="onCellValueChanged($event)"
    (cutStart)="onCutStart($event)"
    (cutEnd)="onCutEnd($event)"
    (pasteStart)="onPasteStart($event)"
    (pasteEnd)="onPasteEnd($event)"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "athlete", minWidth: 200 },
    { field: "age" },
    { field: "country", minWidth: 150 },
    { field: "year" },
    { field: "date", minWidth: 150 },
    { field: "sport", minWidth: 150 },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ];
  defaultColDef: ColDef = {
    editable: true,
    flex: 1,
    minWidth: 100,
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onCellValueChanged(params: CellValueChangedEvent) {
    console.log("Callback onCellValueChanged:", params);
  }

  onCutStart(params: CutStartEvent) {
    console.log("Callback onCutStart:", params);
  }

  onCutEnd(params: CutEndEvent) {
    console.log("Callback onCutEnd:", params);
  }

  onPasteStart(params: PasteStartEvent) {
    console.log("Callback onPasteStart:", params);
  }

  onPasteEnd(params: PasteEndEvent) {
    console.log("Callback onPasteEnd:", params);
  }

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Clipboard Events](https://www.ag-grid.com/examples/clipboard/clipboard-events/angular)
